#include<iostream>
#include<vector>
#include<queue>
#include<set>
using namespace std;
const int maxn = 100100;
int n, m;
vector<int> e[maxn];
int from[maxn];
int depth[maxn];

vector<vector<int> > chains;
vector<int> empty_v;
set<int> ch_t[maxn];

int dfs(int a)
{
    //cout << "~" << a + 1 << endl;
    for(int i = 0; i < e[a].size(); i ++)
    {
        if(depth[e[a][i]] == -2)
        {
            depth[e[a][i]] = depth[a] + 1;
            from[e[a][i]] = a;
            dfs(e[a][i]);
        } else {
            if(depth[a] - 1 > depth[e[a][i]])
            {
                int b = a;
                int x = chains.size();
                chains.push_back(empty_v);
                while(b != from[e[a][i]])
                {
                    chains[x].push_back(b);
                    ch_t[b].insert(x);
                    b = from[b];
                }
                //cout << depth[a] - depth[e[a][i]] << endl;
            }
        }
    }
    return 0;
}

int check_same(int a, int b)
{
    for(set<int>::iterator i = ch_t[a].begin(); i != ch_t[a].end(); i ++)
    {
        if(ch_t[b].count(*i) == 1)
        {
            return *i;
        }
    }
    return -1;
}

int from_bfs[maxn];

int find_longest(int j, int a, int b)
{
    int f = -1;
    for(int i = 0; i < chains[j].size(); i ++)
    {
        if(chains[j][i] == a || chains[j][i] == b)
        {
            if(f == -1) f = i;
            else
            {
                int ans = i - f;
                return max(ans, int(chains[j].size() - ans));
            }
        }
    }
}

int main()
{
    int A, B;
    cin >> n >> m >> A >> B;
    A --;
    B --;
    for(int i = 0; i < m; i ++)
    {
        int a, b;
        cin >> a >> b;
        a --;
        b --;
        e[a].push_back(b);
        e[b].push_back(a);
    }
    for(int i = 0; i < n; i ++)
    {
        from[i] = -2;
        depth[i] = -2;
        from_bfs[i] = -2;
    }
    depth[A] = 0;
    from[A] = -1;
    dfs(A);
/*
    for(int i = 0; i < chains.size(); i ++)
    {
        for(int j = 0; j < chains[i].size(); j ++)
        {
            cout << chains[i][j] + 1 << " ";
        }
        cout << endl;
    }
*/


    queue<int> bfs;
    bfs.push(A);
    from_bfs[A] = -1;
    while(bfs.front() != B)
    {
        int x = bfs.front();
        bfs.pop();
        for(int i = 0; i < e[x].size(); i ++)
        {
            if(from_bfs[e[x][i]] == -2)
            {
                from_bfs[e[x][i]] = x;
                bfs.push(e[x][i]);
            }
        }
    }
/*
    cout << "--------\n";
    for(int i = 0; i < n; i++)
    {
        cout  << i + 1 << "<"<< from_bfs[i] + 1 << " ";
    }
    cout << endl;
*/
    vector<int> path;
    vector<int> path_change;
    int x = B;
    while(x != A)
    {
        int k = check_same(x, from_bfs[x]);
        if(path.empty() || path[path.size() - 1] != k)
        {
            path.push_back(k);
            path_change.push_back(x);
        }
        x = from_bfs[x];
    }
/*
    for(int i = 0; i < path.size(); i ++)
    {
        cout << " -" << path_change[i] + 1 << "->" << path[i];
    }
    cout << endl;
*/
    int last = A;
    int ans = 0;
    for(int i = path.size() - 1; i >= 0; i --)
    {
        ans += find_longest(path[i],last, path_change[i]);
        last = path_change[i];
    }
    cout << ans;
}
/*
10 12 10 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
