#include<iostream>
#include<algorithm>
#include<vector>
#define x first.first
#define y first.second
#define id second
#define point pair<pair<long long,long long>, int>
#include<random>


using namespace std;

int n;
point p[100];
bool is_hull[100];

long long sa(point a, point b, point c)
{
    a.x -= b.x;
    a.y -= b.y;
    c.x -= b.x;
    c.y -= b.y;
    return a.x * c.y - a.y * c.x;
}
void print_hull()
{

    for(int i = 0; i < n; i ++)
    {
        if(is_hull[i])
        {
            cout << p[i].id + 1 << " ";
        }
    }
    cout << endl;
}
bool all_hull()
{
    for(int i = 0; i < n; i ++)
    {
        if(!is_hull[i]) return 0;
    }
    return 1;
}
void find_hull()
{
    sort(p, p + n);
    for(int i = 0; i < n; i ++) is_hull[i] = 0;
    vector<int> hull;
    hull.push_back(0);
    is_hull[0] = 1;
    for(int i = 1; i < n; i ++)
    {
        while(hull.size() >= 2 &&
                sa(p[hull[hull.size() - 2]], p[hull[hull.size() - 1]], p[i]) < 0)
        {
            is_hull[hull[hull.size() - 1]] = 0;
            //cout << hull.size() << endl;
            //cout << "remove" << p[hull[hull.size() - 1]].id + 1 << endl;
            hull.resize(hull.size() - 1);
        }
        is_hull[i] = 1;
        hull.push_back(i);
        //cout << "add" << p[i].id + 1 << endl;
    }
    //print_hull();
    hull.clear();
    hull.push_back(0);
    for(int i = 1; i < n; i ++)
    {
        if(!is_hull[i])
        {
            while(hull.size() >= 2 &&
                    sa(p[hull[hull.size() - 2]], p[hull[hull.size() - 1]], p[i]) > 0)
            {
                is_hull[hull[hull.size() - 1]] = 0;
                hull.resize(hull.size() - 1);
            }
            is_hull[i] = 1;
            hull.push_back(i);
        }
    }
    //print_hull();
}

long long dis(point a, point b)
{
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

void jump(int a ,int b)
{
    point v;
    v.x = p[b].x - p[a].x;
    v.y = p[b].y - p[a].y;
    p[a].x = p[b].x + v.x;
    p[a].y = p[b].y + v.y;
}

int main()
{
    /*point a, b, c;
    a.x = 0;
    a.y = 0;
    b.x = 10;
    b.y = 10;
    c.x = 10;
    c.y = 0;
    cout << sa(a,b,c);
    */
    srand(123);
    cin >> n;
    for(int i = 0; i < n; i ++)
    {
        cin >> p[i].x >> p[i].y;
        p[i].id = i;
    }
    find_hull();
    vector<point> log;
    if(all_hull())
    {
        cout << n - 1 << endl;
        for(int i = 1; i < n; i ++)
        {
            cout  << i + 1<< " 1" << endl;
        }
        return 0;
    }
    while(!all_hull())
    {
        bool found = true;
        for(int i = 0;found &&  i < n; i ++)
        {
            if(!is_hull[i])
            {
                int md = -1;
                for(int j = 0; j < n; j ++)
                {
                    if(is_hull[j])
                    {
                        if(md == -1 || rand() % n == 1)  md = j;
                    }
                }
                point l;
                l.x = p[i].id;
                l.y = p[md].id;
                log.push_back(l);
                jump(i, md);
                //cout << p[i].id << " =>" << p[i].x << " " << p[i].y << endl;
                found = 0;
            }
        }
        find_hull();
    }
    cout << log.size() << endl;
    for(int i = 0; i < log.size(); i ++)
    {
        cout << log[i].x + 1 << " " << log[i].y + 1 << endl;
    }
}
/*
6
3 5
4 3
3 1
11 4
7 7
7 2
*/
/*
3
4 2
5 1
6 2
*/
/*
4
4 0
0 4
5 5
3 3
*/
