#include <stdio.h>
#include <vector>
#define MAXN 100000
using namespace std;

int graph[MAXN+1][5], n, m;
int graphOfFours[MAXN][9], foursCount;

int FindRoadLenBetweenFours(int a, int b)
{
    int prevVertex, currVertex, roadLen, best=-1;
    for (int i=1; i<=4; i++)
    {
        prevVertex=a;
        currVertex=graph[a][i];
        roadLen=1;
        while (graph[currVertex][0]!=4)
        {
            if (graph[currVertex][1]!=prevVertex)
            {
                prevVertex=currVertex;
                currVertex=graph[currVertex][1];
            }
            else
            {
                prevVertex=currVertex;
                currVertex=graph[currVertex][2];
            }
            roadLen++;
        }
        if (currVertex==b)
        {
            if (roadLen>best) best=roadLen;
        }
    }
    return best;
}

void InitGraph()
{
    for (int i=0; i<n; i++)
    {
        graph[i][0]=0;
    }
}

void ReadGraph()
{
    InitGraph();
    int u, v;
    for (int i=0; i<m; i++)
    {
        scanf("%d%d", &u, &v);
        graph[u][graph[u][0]++ + 1]=v;
        graph[v][graph[v][0]++ + 1]=u;
    }
}


void CreateGraphOfFours()
{
    foursCount=0;
    for (int i=1; i<=n; i++)
    {
        if (graph[i][0]==4)
        {
            for (int j=1; j<=8; j++) graphOfFours[foursCount][j]=-1;
            graphOfFours[foursCount++][0]=i;
        }
    }
    int roadLen, fourInd;
    for (int i=0; i<foursCount; i++)
    {
        for (int j=0; j<foursCount; j++)
        {
            if (i==j) continue;
            roadLen=FindRoadLenBetweenFours(graphOfFours[i][0], graphOfFours[j][0]);
            if (roadLen==-1)
            {
                continue;
            }

            for (fourInd=1; fourInd<=7; fourInd+=2)
            {
                if (graphOfFours[i][fourInd]==j)
                {
                    if (graphOfFours[i][fourInd+1]<roadLen)
                    {
                        graphOfFours[i][fourInd+1]=roadLen;
                    }
                    fourInd=-1;
                    break;
                }
                if (graphOfFours[i][fourInd]==-1) break;
            }
            if (fourInd!=-1)
            {
                graphOfFours[i][fourInd]=j;
                graphOfFours[i][fourInd+1]=roadLen;
            }
        }
    }
}

void MakeItFour(int &a)
{
    for (int i=0; i<foursCount; i++)
    {
        if (graphOfFours[i][0]==a)
        {
            a=i;
            return;
        }
    }
}
int LongestPathBetweenFoursLen(int a, int b, int byNow, vector<int> beenTo)
{
    if (a==b)
    {
        return byNow;
    }

    int best=-1, curr;
    bool inBeenTo;
    beenTo.push_back(a);
    for (int i=1; i<=7; i+=2)
    {
        if (graphOfFours[a][i]==-1) break;
        inBeenTo=false;
        for (int j=0; j<beenTo.size()-1; j++)
        {
            if (beenTo[j]==graphOfFours[a][i])
            {
                inBeenTo=true;
                break;
            }
        }
        if (inBeenTo) continue;
        curr=LongestPathBetweenFoursLen(graphOfFours[a][i], b, byNow+graphOfFours[a][i+1], beenTo);
        if (curr>best) best=curr;
    }
    return best;
}

int LongestPathLen(int a, int b)
{
    vector<int> emptyVector;
    if (graph[a][0]==4 && graph[b][0]==4)
    {
        MakeItFour(a);
        MakeItFour(b);
        return LongestPathBetweenFoursLen(a, b, 0, emptyVector);
    }
    int aFour[4], bFour[4];
    if (graph[a][0]!=4)
    {
        int prevVertex, currVertex, roadLen;
        for (int i=1; i<=2; i++)
        {
            prevVertex=a;
            currVertex=graph[a][i];
            roadLen=1;
            while (graph[currVertex][0]!=4)
            {
                if (graph[currVertex][1]!=prevVertex)
                {
                    prevVertex=currVertex;
                    currVertex=graph[currVertex][1];
                }
                else
                {
                    prevVertex=currVertex;
                    currVertex=graph[currVertex][2];
                }
                roadLen++;
            }
            aFour[(i-1)*2]=currVertex;
            MakeItFour(aFour[(i-1)*2]);
            aFour[(i-1)*2+1]=roadLen;
        }
    }
    if (graph[b][0]!=4)
    {
        int prevVertex, currVertex, roadLen;
        for (int i=1; i<=2; i++)
        {
            prevVertex=b;
            currVertex=graph[b][i];
            roadLen=1;
            while (graph[currVertex][0]!=4)
            {
                if (graph[currVertex][1]!=prevVertex)
                {
                    prevVertex=currVertex;
                    currVertex=graph[currVertex][1];
                }
                else
                {
                    prevVertex=currVertex;
                    currVertex=graph[currVertex][2];
                }
                roadLen++;
            }
            bFour[(i-1)*2]=currVertex;
            MakeItFour(bFour[(i-1)*2]);
            bFour[(i-1)*2+1]=roadLen;
        }
    }
    int currPathLen, bestPathLen=-1;
    for (int i=0; i<2; i++)
    {
        for (int j=0; j<2; j++)
        {
            currPathLen = LongestPathBetweenFoursLen(aFour[i*2], bFour[j*2], 0, emptyVector) + aFour[i*2+1] + bFour[j*2+1];
            if (currPathLen > bestPathLen) bestPathLen = currPathLen;
        }
    }
    return bestPathLen;
}

int main()
{
    int a, b;
    scanf("%d%d%d%d", &n, &m, &a, &b);
    ReadGraph();
    CreateGraphOfFours();
    printf("%d\n", LongestPathLen(a, b));
    return 0;
}
