#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
using namespace std;

int n, m, a, b;
vector<vector<int>> gr;
vector<vector<pair<int, int>>> oGr;

void read()
{
    cin>>n>>m>>a>>b;
    gr.resize(n+1);
    for(int i=0;i<m;i++)
    {
        int x, y;
        cin>>x>>y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
}

vector<bool> used;

void optimize(int first, int current, int len)
{
    //printf("opt (%d %d %d)\n", first, current, len);
    if(first!=current && (gr[current].size()>2 || current==a || current==b))
    {
        oGr[first].emplace_back(current, len);
        return;
    }

    for(int next : gr[current])
    {
        if(!used[next])
        {
            used[next] = true;
            optimize(first, next, len + 1);
            used[next] = false;
        }
    }
}

void optimize()
{
    oGr.resize(n+1);

    used[a]=true;
    if(gr[a].size()==2)optimize(a, a, 0);
    used[a]=false;

    used[b]=true;
    if(gr[b].size()==2)optimize(b, b, 0);
    used[b]=false;

    for(int i=1;i<=n;i++)
    {
        if(gr[i].size()>2)
        {
            used[i]=true;
            optimize(i, i, 0);
            used[i]=false;
        }
    }
}

int answer = 0;
void go(int current, int len)
{
    //printf("  go(%d %d)\n", current, len);
    if(current == b)
    {
        answer = max(answer, len);
        return;
    }

    for(auto next : oGr[current])
    {
        if(!used[next.first])
        {
            used[next.first] = true;
            go(next.first, len+next.second);
            used[next.first] = false;
        }
    }
}

void solve()
{
    used.resize(n+1, false);

    optimize();
    /*
    for(int i=1;i<=n;i++)
    {
        printf("%d: ", i);
        for(auto x : oGr[i])printf("%d, %d    ", x.first, x.second);
        putchar('\n');
    }*/

    used[a] = true;
    go(a, 0);
    printf("%d\n", answer);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
}
/**
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
**/
