#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <map>
using namespace std;

int n, m, a, b;
vector<vector<int>> gr;
vector<vector<pair<int, int>>> oGr;
map<pair<int, int>, int> oEdges;

void read()
{
    cin>>n>>m>>a>>b;
    gr.resize(n+1);
    for(int i=0;i<m;i++)
    {
        int x, y;
        cin>>x>>y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
}

vector<bool> used;

void optimize(int first, int current, int len)
{
    //printf("opt (%d %d %d)\n", first, current, len);
    if(first!=current && (gr[current].size()>2 || current==a || current==b))
    {
        //oGr[first].emplace_back(current, len);
        //int &m = oMatrix[first][current];
        auto found = oEdges.find({first, current});
        if(found==oEdges.end() || found->second < len)
        {
            oEdges[{first, current}] = len;
        }

        return;
    }

    for(int next : gr[current])
    {
        if(!used[next])
        {
            used[next] = true;
            optimize(first, next, len + 1);
            used[next] = false;
        }
    }
}

void optimize()
{
    oGr.resize(n+1);
    //oMatrix.resize(n+1, vector<int>(n+1, -1));


    used[a]=true;
    if(gr[a].size()==2)optimize(a, a, 0);
    used[a]=false;

    used[b]=true;
    if(gr[b].size()==2)optimize(b, b, 0);
    used[b]=false;

    for(int i=1;i<=n;i++)
    {
        if(gr[i].size()>2)
        {
            used[i]=true;
            optimize(i, i, 0);
            used[i]=false;
        }
    }

    for(auto x : oEdges)
    {
        oGr[x.first.first].emplace_back(x.first.second, x.second);
    }

    /*for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(oMatrix[i][j]!=-1)
            {
                oGr[i].emplace_back(j, oMatrix[i][j]);
            }
        }
    }*/
}

int answer = 0;
void go(int current)
{
    static int len = 0;

    if(current == b)
    {
        answer = max(answer, len);
        return;
    }

    for(auto next : oGr[current])
    {
        if(!used[next.first])
        {
            used[next.first] = true;
            len+=next.second;

            go(next.first);

            len-=next.second;
            used[next.first] = false;
        }
    }
}

void solve()
{
    used.resize(n+1, false);

    optimize();

    /*
    for(int i=1;i<=n;i++)
    {
        printf("%d: ", i);
        for(auto x : oGr[i])printf("%d, %d    ", x.first, x.second);
        putchar('\n');
    }*/


    used[a] = true;
    go(a);
    used[a] = false;
    printf("%d\n", answer);
}

int main()
{
    //cout<<USHRT_MAX<<endl;
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
}
/**
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1

13 16 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
8 11
11 12
12 13
8 13


**/
