#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; } 
const int MAXN = (1 << 20);

int n, m, A, B;
set<int> adj[MAXN];

void read()
{
	cin >> n >> m >> A >> B;
	for(int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		adj[u].insert(v);
		adj[v].insert(u);
	}
}

int dist[MAXN], par[MAXN];

void bfs(int src)
{
	memset(dist, -1, sizeof(dist));
	queue<int> Q;
	Q.push(src);
	dist[src] = 0;
	par[src] = -1;
	
	while(!Q.empty())
	{
		int u = Q.front();
		Q.pop();
		
		for(int v: adj[u])
			if(dist[v] == -1)
			{
				dist[v] = dist[u] + 1;
				par[v] = u;
				Q.push(v);
			}
	}
}

void solve()
{
	bfs(A);
	
	int u = B;
	while(u != A)
	{
		adj[u].erase(par[u]);
		adj[par[u]].erase(u);
		u = par[u];	  
	}

	bfs(A);
	
	cout << dist[B] << endl;	
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	read();
	solve();
	return 0;
}
