#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; } 
const int inf = (int)1e9 + 17;
const int MAXN = (1 << 10);

int n, k;
string s;
int prv[MAXN];

void read()
{
	cin >> s;
	s = " " + s;
	cin >> k;
	n = s.size() - 1;

	prv[1] = -1;
	for(int i = 2; i <= n; i++)
		if(s[i - 1] == '(') prv[i] = i - 1;
		else prv[i] = prv[i - 1];
}

int dp[MAXN][MAXN];

/*
int cost(int l, int r)
{
	if(r < l) return 0;
	if(l == r) return 0;
	if(l == r - 1) return (s[l] == '(' && s[r] == ')') ? 2 : 0;

	int &memo = dp[l][r];
	if(memo != -1) return memo;
	
	if(s[l] == ')') return memo = cost(l + 1, r);
	if(s[r] == '(') return memo = cost(l, r - 1);
	
	memo = cost(l, r - 1);
	for(int oth = prv[r]; oth >= l; oth = prv[oth])
		chkmax(memo, 2 + cost(l, oth - 1) + cost(oth + 1, r - 1));
	
	return memo;
}*/

int cost(int l, int r) { return dp[l][r]; }

vector<int> res;

void get_list(int l, int r)
{
	if(r < l) return;
	if(r == l) return;
	if(l == r - 1)
	{
		if(s[l] == '(' && s[r] == ')') res.push_back(l), res.push_back(r);
		return;
	}
	
	if(s[l] == ')')
	{
		get_list(l + 1, r);
		return;
	}
	
	if(s[r] == '(')
	{
		get_list(l, r - 1);
		return;
	}
	
	if(cost(l, r - 1) == cost(l, r)) 
	{
		get_list(l, r - 1);
		return;
	}
	
	for(int oth = prv[r]; oth >= l; oth = prv[oth])
		if(s[oth] == '(' && 2 + cost(l, oth - 1) + cost(oth + 1, r - 1) == cost(l, r))
		{
			get_list(l, oth - 1);
			get_list(oth + 1, r - 1);
			res.push_back(oth);
			res.push_back(r);
			return;
		}
}

vector<int> Get(int l, int r)
{
	res.clear();
	get_list(l, r);
	sort(res.begin(), res.end());
	return res;
}

int ans[MAXN][MAXN];

void rec(int l, int r, int opt_l, int opt_r, int k)
{
 	if(r < l) return;
	
	int mid = (l + r) >> 1;
	
	int c_opt = mid;
	ans[mid][k] = inf; 
	for(int i = opt_l; i <= min(mid, opt_r); i++)
	{
		if(ans[mid][k] >= ans[i - 1][k - 1] + cost(i, mid))
			c_opt = i;	
		chkmin(ans[mid][k], ans[i - 1][k - 1] + cost(i, mid));
	}
	
	rec(l, mid - 1, opt_l, c_opt, k);
	rec(mid + 1, r, c_opt, opt_r, k);
}

void solve()
{
	memset(dp, 0, sizeof(dp));
	for(int len = 2; len <= n; len++)
		for(int l = 1; l + len - 1 <= n; l++)
		{
			int r = l + len - 1;
			if(s[l] == ')') dp[l][r] = dp[l + 1][r];
			else if(s[r] == '(') dp[l][r] = dp[l][r - 1];
			else 
			{
				dp[l][r] = dp[l][r - 1];
				for(int oth = prv[r]; oth >= l; oth = prv[oth])
					chkmax(dp[l][r], 2 + dp[l][oth - 1] + dp[oth + 1][r - 1]);
			}
		}
	
	for(int i = 0; i <= n; i++)
		for(int j = 0; j <= k; j++)
			ans[i][j] = inf;
			
	ans[0][0] = 0;
	for(int i = 1; i <= k; i++)
	{
		dp[0][i] = inf;
		rec(1, n, 1, n, i);	
	}
	
	cout << ans[n][k] << endl;

	vector<pair<int, int> > ans1, ans2;

	int ck = k, cp = n;
	while(ck)
	{
		int nxt = -1;
		for(int lst = cp; lst >= 1; lst--)
			if(cost(lst, cp) + ans[lst - 1][ck - 1] == ans[cp][ck])
				nxt = lst;
		
		ans1.push_back(make_pair(nxt, cp));
		cp = nxt - 1;
		ck--;
	}

	cp = n, ck = k;
	while(ck)
	{
		int nxt = -1;
		for(int lst = cp; lst >= 1; lst--)
			if(cost(lst, cp) + ans[lst - 1][ck - 1] == ans[cp][ck])
			{
				nxt = lst;
				break;
			}
			
		ans2.push_back(make_pair(nxt, cp));
		cp = nxt - 1;
		ck--;
	}

	sort(ans1.begin(), ans1.end());
	sort(ans2.begin(), ans2.end());
	
	for(int i = 0; i < ans1.size(); i++)
	{
		int l = ans1[i].first, r = ans1[i].second;	
		cout << i + 1 << ",[" << l << "," << r << "],";
		
		vector<int> p = Get(l, r);
		cout << p.size() << ":";
		for(int x: p) cout << x << " ";
		cout << endl;
	}
	
	ans1 = ans2;
		
	for(int i = 0; i < ans1.size(); i++)
	{
		int l = ans1[i].first, r = ans1[i].second;	
		cout << i + 1 << ",[" << l << "," << r << "],";
		
		vector<int> p = Get(l, r);
		cout << p.size() << ":";
		for(int x: p) cout << x << " ";
		cout << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	read();
	solve();
	return 0;
}
