#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <algorithm>

using namespace std;

string input;

int check (int from, int to)
{
	int skip = 0;
	stack < int > open;
	for (int i = from ; i < to ; i ++)
		if (input [i] == '(')
			open.push (i);
		else if (not open.empty ())
			open.pop ();
		else
			skip ++;
	return to - from - open.size () - skip;
}

void print_indexes (int from, int to)
{
	vector < int > closed;
	vector < int > open;
	for (int i = from ; i < to ; i ++)
		if (input [i] == '(')
			open.push_back (i);
		else if (not open.empty ())
			open.pop_back ();
		else
			closed.push_back (i);
	
	int ind_open = 0, ind_closed = 0;
	for (int i = from ; i < to ; i ++)
		if (ind_open < open.size () and i == open [ind_open])
			ind_open ++;
		else if (ind_closed < closed.size () and i == closed [ind_closed])
			ind_closed ++;
		else
			cout << i + 1 << " ";
}

void print (const vector < pair < int, int > > parts)
{
	for (int i = 0 ; i < parts.size () ; i ++)
	{
		cout << i + 1 << ", [" << parts [i].first + 1 << ", " << parts [i].second << "], " << check (parts [i].first, parts [i].second) << ": ";
		print_indexes (parts [i].first, parts [i].second);
		cout << endl;
	}
	cout << endl;
}

vector < pair < int, int > > parts;
set < vector < pair < int, int > > > answers;
int min_sum = 1e9;

void rec (int from, int parts_left, int sum = 0)
{
	//for (int i = 0 ; i < 3 - parts_left ; i ++)
	//	cout << " ";
	//cout << from << " " << parts_left << " " << sum << " " << min_sum << endl;
	if (from > input.size () - 1)
		return;
	if (sum > min_sum)
		return;
	if (parts_left == 1)
	{
		sum += check (from, input.size ());
		if (sum < min_sum)
		{
			answers.clear ();
			//cout << answers.size () << endl;
			min_sum = sum;
		}
		parts.push_back ({from, input.size ()});
		//print (parts);
		answers.insert (parts);
		parts.pop_back ();
		return ;
	}
	if (from == input.size () - 1)
	{
		return;
	}
	for (int i = from ; i < input.size () ; i ++)
	{
		parts.push_back ({from, i + 1});
		rec (i + 1, parts_left - 1, sum + check (from, i + 1));
		parts.pop_back ();
	}
}

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);
	cin >> input;
	int k;
	cin >> k;
	rec (0, k);
	print (*answers.begin ());
	print (*prev(answers.end ()));
}

