#include <iostream>
#include <vector>
#include <queue>

using namespace std;

vector < int > ln [100000];

int e;

short visited [100000];
vector < int > critical;
vector < vector < int > > components;
int vertex_comp [100000];
vector < vector < int > > components_crits;

void gen_comp (int n)
{
	for (auto& x : visited)
		x = false;
	//cout << endl;
	queue < int > q;
	
	for (int i = 0 ; i < n ; i ++)
		if (not visited [i])
		{ 
			for (auto& x : critical)
			{
				//cout << x + 1 << " ";
				visited [x] = 2;
			}
			components.push_back ({});
			components_crits.push_back ({});
			//cout << "New Component: ";
			q.push (i);

			visited [q.front ()] = true;

			while (!q.empty ())
			{
				auto f = q.front (); q.pop ();
				//cout << f + 1 << " ";
				components [components.size () - 1].push_back (f);
				vertex_comp [f] = components.size ();

				for (auto& x : ln [f])
				{
					if (not visited [x])
					{
						visited [x] = true;
						q.push (x);
					}
					else if (visited [x] == 2)
					{
						//cout << " crit(" << x + 1 << ") ";
						visited [x] = 1;
						components [components.size () - 1].push_back (x);
						components_crits [components.size () - 1].push_back (x);
					}
				}
			}
			//cout << endl;
		}

	return;
}

bool bfs (int n)
{
	for (auto& x : visited)
		x = false;
	//cout << "Critical: ";

	{
		auto& x = critical.back ();
		//cout << x + 1 << " ";
		visited [x] = true;
	}
	//cout << endl;
	queue < int > q;
	
	int components = 0;

	for (int i = 0 ; i < n ; i ++)
		if (not visited [i])
		{ 
			components ++;
			//cout << "New Component: ";
			q.push (i);

			visited [q.front ()] = true;

			while (!q.empty ())
			{
				auto f = q.front (); q.pop ();
				//cout << f + 1 << " ";

				for (auto& x : ln [f])
					if (not visited [x])
					{
						visited [x] = true;
						q.push (x);
					}
			}
		}

	return (components == 2);
}

int dfs (int s, int comp, int depth = 0)
{
	//for (int i = 0 ; i < depth ; i ++)
	//	cout << " ";
	//cout << s + 1 << " " << comp << "\n";
	if (s == e)
		return 0;

	if (comp != 0)
	{
		int Max = -1e9;
		bool max_in_comp = true;
		for (auto& x : ln [s])
			if (not visited [x] and vertex_comp [x] == comp)
			{
				visited [x] = true;
				Max = max (Max, dfs (x, comp, depth + 1) + 1);
				visited [x] = false;
				max_in_comp = false;
			}
		if (max_in_comp)
			for (auto& x : ln [s])
				if (not visited [x] and vertex_comp [x] == 0)
				{
					visited [x] = true;
					Max = max (Max, dfs (x, 0, depth + 1) + 1);
					visited [x] = false;
					max_in_comp = false;
				}
		return Max;
	}
	else
	{
		int Max = -1e9;
		bool max_in_comp = true;
		for (auto& x : ln [s])
			if (not visited [x])
			{
				visited [x] = true;
				Max = max (Max, dfs (x, vertex_comp [x], depth + 1) + 1);
				visited [x] = false;
				max_in_comp = false;
			}
		return Max;
	}
}

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);
	int n, m, s;
	cin >> n >> m >> s >> e;
	s --;
	e --;
	for (int i = 0 ; i < m ; i ++)
	{
		int a, b;
		cin >> a >> b;
		a --; b --;

		ln [a].push_back (b);
		ln [b].push_back (a);
	}

	for (int i = 0 ; i < n ; i ++)
	{
		critical.push_back (i);
		if (not bfs (n))
			critical.pop_back ();
		//cout << endl;
	}
	gen_comp (n);
	//for (auto& x : critical)
	//	cout << x + 1 << " ";
	//for (auto& x : components)
	//{
	//	for (auto& y : x)
	//		cout << y + 1 << " ";
	//	cout << endl;
	//}
	//for (int i = 0 ; i < n ; i ++)
	//	cout << vertex_comp [i] << " ";
	//cout << endl;
	for (auto& x : visited)
		x = false;
	visited [s] = true;
	cout << dfs (s, vertex_comp [s]) << endl;
}

