#include <iostream>
#include <vector>
#include <queue>

using namespace std;

using vertex_t = unsigned int;
using answer_t = unsigned long long;
using comp_t = unsigned int;

const answer_t NOT_FOUND = -1;
const vertex_t MAXN = 1000000;
vector < vertex_t > ln [MAXN];

vertex_t e;

short visited [MAXN];
vector < vertex_t > critical;
vector < vector < vertex_t > > components;
comp_t vertex_comp [MAXN];
vector < vector < vertex_t > > components_crits;

void gen_comp (vertex_t n)
{
	for (auto& x : visited)
		x = false;
	//cout << endl;
	queue < vertex_t > q;
	
	for (vertex_t i = 0 ; i < n ; i ++)
		if (not visited [i])
		{ 
			for (auto& x : critical)
			{
				//cout << x + 1 << " ";
				visited [x] = 2;
			}
			components.push_back ({});
			components_crits.push_back ({});
			//cout << "New Component: ";
			q.push (i);

			visited [q.front ()] = true;

			while (!q.empty ())
			{
				auto f = q.front (); q.pop ();
				//cout << f + 1 << " ";
				components [components.size () - 1].push_back (f);
				vertex_comp [f] = components.size ();

				for (auto& x : ln [f])
				{
					if (not visited [x])
					{
						visited [x] = true;
						q.push (x);
					}
					else if (visited [x] == 2)
					{
						//cout << " crit(" << x + 1 << ") ";
						visited [x] = 1;
						components [components.size () - 1].push_back (x);
						components_crits [components.size () - 1].push_back (x);
					}
				}
			}
			//cout << endl;
		}

	return;
}
/*
bool bfs (vertex_t n)
{
	for (auto& x : visited)
		x = false;
	//cout << "Critical: ";

	{
		auto& x = critical.back ();
		//cout << x + 1 << " ";
		visited [x] = true;
	}
	//cout << endl;
	queue < vertex_t > q;
	
	comp_t components = 0;

	for (vertex_t i = 0 ; i < n ; i ++)
		if (not visited [i])
		{ 
			components ++;
			//cout << "New Component: ";
			q.push (i);

			visited [q.front ()] = true;

			while (!q.empty ())
			{
				auto f = q.front (); q.pop ();
				//cout << f + 1 << " ";

				for (auto& x : ln [f])
					if (not visited [x])
					{
						visited [x] = true;
						q.push (x);
					}
			}
		}

	return (components == 2);
}*/

answer_t dfs (vertex_t s, comp_t comp, int depth = 0)
{
	//for (int i = 0 ; i < depth ; i ++)
	//	cout << " ";
	//cout << s + 1 << " " << comp << "\n";
	if (s == e)
		return 0;

	if (comp != 0)
	{
		answer_t Max = NOT_FOUND;
		bool max_in_comp = true;
		for (auto& x : ln [s])
			if (not visited [x] and vertex_comp [x] == comp)
			{
				visited [x] = true;
				answer_t d = dfs (x, comp);
				if (d != NOT_FOUND)
				{
					if (Max != NOT_FOUND)
						Max = max (Max, d + 1);
					else 
						Max = d + 1;
				}
				visited [x] = false;
				max_in_comp = false;
			}
		if (max_in_comp)
			for (auto& x : ln [s])
				if (not visited [x] and vertex_comp [x] == 0)
				{
					visited [x] = true;
					answer_t d = dfs (x, 0);
					if (d != NOT_FOUND)
					{
						if (Max != NOT_FOUND)
							Max = max (Max, d + 1);
						else 
							Max = d + 1;
					}
					visited [x] = false;
					max_in_comp = false;
				}
		return Max;
	}
	else
	{
		answer_t Max = NOT_FOUND;
		for (auto& x : ln [s])
			if (not visited [x])
			{
				visited [x] = true;
				answer_t d = dfs (x, vertex_comp [x]);
				if (d != NOT_FOUND)
				{
					if (Max != NOT_FOUND)
						Max = max (Max, d + 1);
					else 
						Max = d + 1;
				}
				visited [x] = false;
			}
		return Max;
	}
}

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);
	vertex_t n, s;
	answer_t m;
	cin >> n >> m >> s >> e;
	s --;
	e --;
	for (answer_t i = 0 ; i < m ; i ++)
	{
		vertex_t a, b;
		cin >> a >> b;
		a --; b --;

		ln [a].push_back (b);
		ln [b].push_back (a);
	}

	for (vertex_t i = 0 ; i < n ; i ++)
	{
		if (ln [i].size () == 4)
		{
			critical.push_back (i);
		}
		//if (not bfs (n))
		//	critical.pop_back ();
		//cout << endl;
	}
	gen_comp (n);
	//for (auto& x : critical)
	//	cout << x + 1 << " ";
	//for (auto& x : components)
	//{
	//	for (auto& y : x)
	//		cout << y + 1 << " ";
	//	cout << endl;
	//}
	//for (int i = 0 ; i < n ; i ++)
	//	cout << vertex_comp [i] << " ";
	//cout << endl;
	for (auto& x : visited)
		x = false;
	visited [s] = true;
	cout << dfs (s, vertex_comp [s]) << endl;
}

