#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <algorithm>

using namespace std;

string input;

int check (int from, int to)
{
	int skip = 0;
	stack < int > open;
	for (int i = from ; i < to ; i ++)
		if (input [i] == '(')
			open.push (i);
		else if (not open.empty ())
			open.pop ();
		else
			skip ++;
	return to - from - open.size () - skip;
}

void print_indexes (int from, int to, int count)
{
	vector < int > closed;
	vector < int > open;
	for (int i = from ; i < to ; i ++)
		if (input [i] == '(')
			open.push_back (i);
		else if (not open.empty ())
			open.pop_back ();
		else
			closed.push_back (i);
	
	unsigned ind_open = 0, ind_closed = 0;
	for (int i = from ; i < to ; i ++)
		if (ind_open < open.size () and i == open [ind_open])
			ind_open ++;
		else if (ind_closed < closed.size () and i == closed [ind_closed])
			ind_closed ++;
		else
		{
			if (count > 1)
				cout << i + 1 << " ";
			else if (count == 1)
				cout << i + 1;
			count --;
		}
}

int dp [1024][1024];

void print (const vector < pair < int, int > > parts)
{
	for (unsigned i = 0 ; i < parts.size () ; i ++)
	{
		int checked = dp [parts [i].first][parts [i].second];
		cout << i + 1 << ",[" << parts [i].first + 1 << "," << parts [i].second << "]," << checked << ":";
		print_indexes (parts [i].first, parts [i].second, checked);
		cout << endl;
	}
}

vector < pair < int, int > > parts;
vector < vector < pair < int, int > > > answers;
auto compare = less < vector < pair < int, int > > > ();
unsigned min_sum = 1e9;

void rec (unsigned from, unsigned parts_left, unsigned sum = 0)
{
	if (from > input.size () - 1)
		return;
	if (sum > min_sum)
		return;
	if (parts_left == 1)
	{
		sum += dp [from][input.size ()];
		if (sum < min_sum)
		{
			answers.clear ();
			//cout << answers.size () << endl;
			min_sum = sum;
		}
		parts.push_back ({from, input.size ()});
		//print (parts);
		if (answers.size () > 1) 
		{
			if (compare (parts, *answers.begin ()))
			{
				answers [0] = parts;
			}
			if (compare (*prev(answers.end ()), parts))
			{
				answers [1] = parts;
			}
		}
		else
		{
			answers.push_back (parts);
			if (answers.size () == 2)
				if (compare (answers [1], answers [0]))
					swap (answers [1], answers [0]);
		}
		parts.pop_back ();
		return ;
	}
	if (from == input.size () - 1)
		return;
	for (unsigned i = from ; i < input.size () ; i ++)
	{
		parts.push_back ({from, i + 1});
		rec (i + 1, parts_left - 1, sum + dp [from][i + 1]);
		parts.pop_back ();
	}
}
int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);
	cin >> input;
	int k;
	cin >> k;

	for (unsigned i = 0 ; i < input.size (); i ++)
	{
		int skip = 0;
		stack < int > open;
		for (unsigned j = i ; j < input.size (); j ++)
		{
			if (input [j] == '(')
				open.push (j);
			else if (not open.empty ())
				open.pop ();
			else
				skip ++;
			dp [i][j + 1] = j + 1 - i - open.size () - skip;
		}
	}
	rec (0, k);
	cout << min_sum << endl;
	print (*answers.begin ());
	print (*prev(answers.end ()));
}

