#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <algorithm>

using namespace std;

string input;

int check (int from, int to)
{
	int skip = 0;
	stack < int > open;
	for (int i = from ; i < to ; i ++)
		if (input [i] == '(')
			open.push (i);
		else if (not open.empty ())
			open.pop ();
		else
			skip ++;
	return to - from - open.size () - skip;
}

void print_indexes (int from, int to, int count)
{
	vector < int > closed;
	vector < int > open;
	for (int i = from ; i < to ; i ++)
		if (input [i] == '(')
			open.push_back (i);
		else if (not open.empty ())
			open.pop_back ();
		else
			closed.push_back (i);
	
	unsigned ind_open = 0, ind_closed = 0;
	for (int i = from ; i < to ; i ++)
		if (ind_open < open.size () and i == open [ind_open])
			ind_open ++;
		else if (ind_closed < closed.size () and i == closed [ind_closed])
			ind_closed ++;
		else
		{
			if (count > 1)
				cout << i + 1 << " ";
			else if (count == 1)
				cout << i + 1;
			count --;
		}
}

int dp [1024][1024];

//void print (const vector < pair < int, int > > parts)
//{
//	for (unsigned i = 0 ; i < parts.size () ; i ++)
//	{
//		int checked = dp [parts [i].first][parts [i].second];
//		cout << i + 1 << ",[" << parts [i].first + 1 << "," << parts [i].second << "]," << checked << ":";
//		print_indexes (parts [i].first, parts [i].second, checked);
//		cout << endl;
//	}
//}

int mem [1024][256];

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);
	cin >> input;
	int k;
	cin >> k;

	for (unsigned i = 0 ; i < input.size (); i ++)
	{
		int skip = 0;
		stack < int > open;
		for (unsigned j = i ; j < input.size (); j ++)
		{
			if (input [j] == '(')
				open.push (j);
			else if (not open.empty ())
				open.pop ();
			else
				skip ++;
			dp [i][j + 1] = j + 1 - i - open.size () - skip;
		}
	}

	for (int parts = 0 ; parts <= k ; parts ++)
		for (int to = 0 ; to < input.size () ; to ++)
			mem [to][parts] = 1e9;
	for (int parts = 1 ; parts <= k ; parts ++)
	{
		if (parts == 1)
			for (int to = 0 ; to < input.size () ; to ++)
				mem [to][parts] = dp [0][to + 1];
		else
			for (int to = parts - 1 ; to < input.size () ; to ++)
			{
				//cout << parts << " " << to << ":" << endl;
				for (int from = 0 ; from < to ; from ++)
				{
					//cout << "\tto " << from << " + [" << from + 1 << ", " << to << "] -> " << mem [from][parts - 1]  << "+" << dp [from + 1][to + 1] << " => ";
					mem [to][parts] = min (mem [to][parts], mem [from][parts - 1] + dp [from + 1][to + 1]);
					//cout << mem [to][parts] << endl;
				}
			}

	}
	
	//cout << "  ";
	//for (int parts = 1 ; parts <= k ; parts ++)
	//	cout << parts << " ";
	//cout << endl;

	cout << mem [input.size () - 1][k] << endl;

	//backtracking
	int parts = k, to = input.size () - 1;
	stack < pair < int, int > > st;
	while (parts > 1)
	{
		for (int from = 0 ; from < to ; from ++)
			if (mem [to][parts] == mem [from][parts - 1] + dp [from + 1][to + 1])
			{
				st.push ({from + 1, to});
				parts --;
				to = from;
				break;
			}
	}
	st.push ({0, to});
	int counter = 1;
	while (!st.empty ())
	{
		auto t = st.top (); st.pop ();
		cout << counter ++ << ",["<< t.first + 1 << "," << t.second + 1 << "]," << dp [t.first][t.second + 1] << ":";
		print_indexes (t.first, t.second + 1, dp [t.first][t.second + 1]);
		cout << endl;
	}

	//backtracking
	parts = k, to = input.size () - 1;
	while (parts > 1)
	{
		for (int from = to - 1 ; from >= 0 ; from --)
			if (mem [to][parts] == mem [from][parts - 1] + dp [from + 1][to + 1])
			{
				st.push ({from + 1, to});
				parts --;
				to = from;
				break;
			}
	}
	st.push ({0, to});
	counter = 1;
	while (!st.empty ())
	{
		auto t = st.top (); st.pop ();
		cout << counter ++ << ",["<< t.first + 1 << "," << t.second + 1 << "]," << dp [t.first][t.second + 1] << ":";
		print_indexes (t.first, t.second + 1, dp [t.first][t.second + 1]);
		cout << endl;
	}
}

