#include <iostream>
#include <vector>
#include <cstdint>

using namespace std;

#define MOD 2000000000ULL
#define K   13U

uint32_t a, b;

vector < vector < uint32_t > > ss;
vector < bool > used;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n, m;
    cin>>n>>m>>a>>b;
    a--;
    b--;
    ss.resize(n);
    used.resize(n);
    used[a]=true;
    uint32_t u, v;
    for(uint32_t i=0; i<m; i++)
    {
        cin>>u>>v;
        u--; v--;
        ss[u].push_back(v);
        ss[v].push_back(u);
    }
}

template<class T>
T fast_pow (T a, T b, T mod)
{
    T res=1;
    while(b>0)
    {
        if(b&1)
        {
            res=a*res%mod;
        }
        a=a*a%mod;
        b>>=1;
    }
    return res;
}

uint32_t res=0;

uint64_t hash_val (uint32_t cur)
{
    uint64_t res=cur;
    //cur=cur%MOD;
    for(uint32_t i=0; i<used.size(); i++)
    {
        if(used[i])
        {
            res+=fast_pow<uint64_t>(K, i+1, MOD);
            res=res%MOD;
        }
    }
    return res;
}

vector < bool > mem;

void rec (uint32_t cur=a, uint32_t cur_br=0)
{
    uint64_t hash_v=hash_val(cur);
    //cout<<"Current hash:"<<hash_v<<endl;
    if(mem[hash_v])return;
    mem[hash_v]=true;
    if(cur==b)
    {

        if(cur_br>res)
            res=cur_br;

        return;
    }

    for(uint32_t i=0; i<ss[cur].size(); i++)
    {
        if(used[ss[cur][i]])continue;
        used[ss[cur][i]]=true;
        rec(ss[cur][i], cur_br+1);
        used[ss[cur][i]]=false;
    }
}

int main()
{
    mem.resize(MOD);
    init();
    rec();
    cout<<res<<endl;

    return 0;
}
