#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <deque>
#include <cstdint>
using namespace std;

#define endl '\n'

vector <bool> scopes;
uint32_t k;

struct res_s
{
    vector < uint32_t > vc;
    uint32_t b, e;
};

uint32_t cur_br=0, best_br=UINT32_MAX;
vector < res_s > cur_sc, best1_sc, best2_sc;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    string s;
    cin>>s;
    cin>>k;
    scopes.resize(s.size());
    for(uint32_t i=0; i<s.size(); i++)
    {
        if(s[i]==')')scopes[i]=true;
    }

    cur_sc.reserve(k);
    best1_sc.reserve(k);
    best2_sc.reserve(k);
}

void find_good (uint32_t begin, uint32_t end, vector<uint32_t> &vc)
{
    //uint32_t br_o=0;
    vc.reserve(end-begin);
    uint32_t br_z=0;
    for(uint32_t i=begin; i<end; i++)
    {
        if(scopes[i])br_z++;
        //else br_o++;
    }
    deque <uint32_t> otv;
    for(uint32_t i=begin; i<end; i++)
    {
        if(!scopes[i])
        {
            otv.push_back(i);
            //cout<<"ASD: "<<br_z<<' '<<otv.size()<<endl;
            while(br_z<otv.size())
            {
                otv.pop_front();
                //cout<<"ASD: "<<br_z<<' '<<otv.size()<<endl;
            }
        }
        else
        {
            br_z--;
            if(otv.size()>0)
            {
                vc.push_back(i);
                vc.push_back(otv.front());
                otv.pop_front();
            }
        }
    }
    vc.shrink_to_fit();

}

bool push_sc (uint32_t b, uint32_t e)
{
    res_s r;
    r.b=b;
    r.e=e;
    find_good(b, e, r.vc);
    if(cur_br+r.vc.size()>best_br)return false;
    cur_sc.push_back(r);
    cur_br+=r.vc.size();
    return true;
}

void pop_sc ()
{
    cur_br-=cur_sc.back().vc.size();
    cur_sc.pop_back();
}

void check_best()
{
    /*cout<<"----------------------"<<endl;
    cout<<cur_br<<endl;
    for(auto x:cur_sc)
    {
        cout<<"ASD:"<<x.b<<' '<<x.e<<endl;
        for(auto y:x.vc)
            cout<<y<<' ';
        cout<<endl;
    }
    cout<<"----------------------"<<endl;*/
    if(cur_br<best_br)
    {
        best1_sc=cur_sc;
        best2_sc=cur_sc;
        best_br=cur_br;
        return;
    }
    else if(cur_br==best_br)
    {
        for(int32_t i=k-1; i>=0; i--)
        {
            if(cur_sc[i].vc.size()>best1_sc[i].vc.size())
            {
                best1_sc=cur_sc;
                break;
            }
            else if(cur_sc[i].vc.size()<best1_sc[i].vc.size())
                break;
        }

        for(int32_t i=k-1; i>=0; i--)
        {
            if(cur_sc[i].vc.size()>best2_sc[i].vc.size())
            {
                best2_sc=cur_sc;
                break;
            }
            else if(cur_sc[i].vc.size()>best2_sc[i].vc.size())
                break;
        }
    }
}

void rec(uint32_t cur_pos=0)
{
    if(cur_br>best_br)return;
    if(cur_sc.size()+1==k)
    {
        if(push_sc(cur_pos, scopes.size()))
        {
            check_best();
            pop_sc();
        }
        return;
    }
    for(uint32_t i=cur_pos+1; i<=scopes.size()-(k-cur_sc.size())+1; i++)
    {
        if(push_sc(cur_pos, i))
        {
            rec(i);
            pop_sc();
        }
    }
}

int main()
{
    init();

    //vector<uint32_t> vc;
    //find_good(0, scopes.size(), vc);
    //sort(vc.begin(), vc.end());
    //for(uint32_t i=0; i<vc.size(); i++)
    //    cout<<vc[i]<<' ';
    //cout<<endl;

    rec();

    /*for(auto x:best1_sc)
    {
        cout<<"ASD:"<<x.b<<' '<<x.e<<endl;
        for(auto y:x.vc)
            cout<<y<<' ';
        cout<<endl;
    }
    cout<<"------------------------";*/

    cout<<best_br<<endl;

    for(uint32_t i=0; i<k; i++)
    {
        cout<<i+1<<",["<<best1_sc[i].b+1<<','<<best1_sc[i].e<<"],"<<best1_sc[i].vc.size()<<':';
        sort(best1_sc[i].vc.begin(), best1_sc[i].vc.end());
        for(uint32_t j=0; j<best1_sc[i].vc.size(); j++)
            cout<<best1_sc[i].vc[j]+1<<' ';
        cout<<endl;
    }

    for(uint32_t i=0; i<k; i++)
    {
        cout<<i+1<<",["<<best2_sc[i].b+1<<','<<best2_sc[i].e<<"],"<<best2_sc[i].vc.size()<<':';
        sort(best2_sc[i].vc.begin(), best2_sc[i].vc.end());
        for(uint32_t j=0; j<best2_sc[i].vc.size(); j++)
            cout<<best2_sc[i].vc[j]+1<<' ';;
        cout<<endl;
    }

    return 0;
}
