#include<iostream>
#include<cstring>
#include<climits>
#include<vector>
#include<random>
#include<cmath>
#include<algorithm>

using namespace std;

const int MAXN = 105;

struct point
{
    int x, y;
    int index;
};
point pivot;

int calcFace(point A, point B, point C)
{
    return (A.x*B.y + A.y*C.x + B.x*C.y) - (A.y*B.x + A.x*C.y + B.y*C.x);
}

bool operator <(const point A, const point B)
{
    if(calcFace(pivot, A, B)<0) return true;
    return false;
}

int n;
point a[MAXN];

int length = 0;
vector <point> convexHull(MAXN);

vector < pair <int, int> > answer;

pair <int, int> jump(point A, point B)
{
    int x, y;
    pair <int, int> answer;

    x = B.x - A.x;
    y = B.y - A.y;

    answer.first = B.x + x;
    answer.second = B.y + y;

    return answer;
}

bool used[MAXN];

int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(NULL);

    pair <int, int> newPos;

    int index;
    int smallestX, smallestY;

    cin >> n;
    for(int i = 0;i<n;i++)
    {
        cin >> a[i].x >> a[i].y;
        a[i].index = i;
    }

    do
    {
        memset(used, false, sizeof(used));

        smallestX = INT_MAX;
        smallestY = INT_MAX;
        for(int i = 0;i<n;i++)
        {
            if(a[i].x<smallestX)
            {
                smallestX = a[i].x;
                smallestY = a[i].y;
                pivot.index = i;
            }
            else if(a[i].x==smallestX && a[i].y<smallestY)
            {
                smallestX = a[i].x;
                smallestY = a[i].y;
                pivot.index = i;
            }
        }

        pivot.x = smallestX;
        pivot.y = smallestY;
        sort(a, a+n);

        length = 1;
        convexHull[0] = pivot;

        used[ pivot.index ] = true;
        for(int i = 1;i<n;i++)
        {
            //cout << i << " --> " << a[i].x << " " << a[i].y << '\n';
            used[ a[i].index ] = true;

            index = length - 1;
            while(index>=1)
            {
                //cout << calcFace(convexHull[index-1], convexHull[index], a[i]) << '\n';

                if(calcFace(convexHull[index-1], convexHull[index], a[i])>0)
                {
                    used[ convexHull[index].index ] = false;

                    index--;
                    length--;
                }
                else break;
            }

            convexHull[length] = a[i];
            length++;
        }

        //for(int i = 0;i<length;i++)
        //    cout << convexHull[i].x << " -- " << convexHull[i].y << '\n';

        for(int i = 0;i<n;i++)
        {
            if(used[ a[i].index ]==false)
            {
                index = rand()%length;

                newPos = jump(a[i], convexHull[index]);
                a[i].x = newPos.first;a[i].y = newPos.second;

                //cout << a[i].index << " " << convexHull[index].index << '\n';
                answer.push_back(make_pair(a[i].index, convexHull[index].index));
            }
        }
    }
    while(length!=n);

    cout << answer.size() << '\n';
    for(int i = 0;i<answer.size();i++)
        cout << answer[i].first + 1 << " " << answer[i].second + 1 << '\n';
}
