#include<iostream>
#include<cstring>
#include<climits>
#include<vector>

using namespace std;

const int MAXN = 1005, MAXK = 205;

struct row
{
    int l, r;
    vector <int> braces;
};

int n, k;
string a;

int dp[MAXN][MAXK];
int segmentValue[MAXN][MAXN], braceDp[MAXN][MAXN];

bool braceDpSkip[MAXN][MAXN];
int maxValue[MAXN][2], maxValueIndex[MAXN][2];
int dpPred[MAXN][MAXK], braceDpPred[MAXN][MAXN];

int openning = 0;

row add;
vector <row> answer;

void calc4Segment(int l, int r)
{
    for(int i = l;i<=l;i++)
    {
        openning = 0;
        segmentValue[i][i] = 0;
        memset(braceDp, false, sizeof(braceDp));
        memset(maxValue, false, sizeof(maxValue));

        if(a[i]=='(')
        {
            braceDp[i][1] = 1;
            maxValue[1][0] = 1;
            braceDpPred[i][1] = -1;
            maxValueIndex[1][0] = i;

            openning = 1;
        }

        for(int j = i+1;j<=r;j++)
        {
            if(a[j]=='(')
            {
                braceDp[j][0] = braceDp[j-1][0];
                braceDpPred[j][0] = j-1;
                braceDpSkip[j][0] = true;

                for(int p = 1;p<=openning+1;p++)
                {
                    braceDp[j][p] = braceDp[j-1][p];
                    braceDpPred[j][p] = braceDpPred[j-1][p];
                    braceDpSkip[j][p] = true;

                    maxValueIndex[p][1] = maxValueIndex[p][0];

                    if(braceDp[j][p] <= maxValue[p-1][0] + 1)
                    {
                        braceDp[j][p] = maxValue[p-1][0] + 1;

                        braceDpSkip[j][p] = false;
                        braceDpPred[j][p]= maxValueIndex[p-1][0];

                        maxValueIndex[p][1] = j;

                    }

                    maxValue[p][1] = braceDp[j][p];
                }

                openning++;
            }
            else
            {
                for(int p = 0;p<=openning-1;p++)
                {
                    braceDp[j][p] = braceDp[j-1][p];
                    braceDpPred[j][p] = j-1;
                    braceDpSkip[j][p] = true;

                    //if(i==0 && j==2 && p==0) cout << braceDp[j][p] << " " << maxValue[p+1][0] + 1 << '\n';

                    maxValueIndex[p][1] = maxValueIndex[p][0];
                    if(maxValue[p+1]==0) continue;

                    if( braceDp[j][p] < maxValue[p+1][0] + 1)
                    {
                        //if(i==0 && j==2 && p==0) cout << "OK" << '\n';

                        braceDp[j][p] = maxValue[p+1][0] + 1;
                        braceDpSkip[j][p] = false;
                        braceDpPred[j][p] = maxValueIndex[p+1][0];

                        maxValueIndex[p][1] = j;
                    }
                    maxValue[p][1] = braceDp[j][p];
                }
            }

            for(int p = 0;p<=openning;p++)
            {
                maxValue[p][0] = maxValue[p][1];
                maxValueIndex[p][0] = maxValueIndex[p][1];
            }

            //cout << i << " " << j << " --> " << braceDp[j][0] << '\n';
            segmentValue[i][j] = braceDp[j][0];
        }
    }
}

void makeAndPrint()
{
    answer.clear();
    int index, index1, waiting, waiting1;

    index = n-1;
    for(int i = 0;i<k;i++)
    {
        add.r = index;
        add.l = dpPred[index][k-i] + 1;
        calc4Segment(add.l, add.r);

        waiting = 0;
        index1 = add.r;
        add.braces.clear();
        for(int j = 0;j<segmentValue[add.l][add.r];)
        {
            //cout << "check " << index1 << " " << segmentValue[add.l][add.r] << " || " << add.l << " " << add.r << '\n';

            //cout << index1 << " " << waiting << " --> " << j << '\n';

            waiting1 = waiting;
            if(braceDpSkip[index1][waiting]==false)
            {
                add.braces.push_back(index1);
                //cout << index1 << " ";

                if(a[index1]==')') waiting1++;
                else waiting1--;

                j++;
            }

            index1 = braceDpPred[index1][ waiting ];
            waiting = waiting1;
        }
        //cout << '\n';

        index = dpPred[index][k-i];
        answer.push_back(add);

        //cout << add.l << " -- " << add.r << '\n';
    }

    for(int i = k-1;i>=0;i--)
    {
        cout << k - i << ",[";
        cout << answer[i].l + 1 << "," << answer[i].r + 1 << "],";
        cout << answer[i].braces.size() << ":";

        for(int j = answer[i].braces.size()-1;j>=0;j--)
            cout << answer[i].braces[j] + 1 << " ";
        cout << '\n';
    }
}

int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(NULL);

    cin >> a;
    cin >> k;
    n = a.size();

    for(int i = 0;i<n;i++)
    {
        calc4Segment(0, i);
        dp[i][1] = segmentValue[0][i];

        dpPred[i][1] = -1;
    }


    for(int i = 1;i<n;i++)
    {
        for(int p = 2;p<=k;p++)
        {
            dp[i][p] = INT_MAX;
            for(int j = 0;j<i;j++)
            {
                calc4Segment(j+1, i);
                if( dp[j][p-1] + segmentValue[j+1][i] < dp[i][p] )
                {
                    dp[i][p] = dp[j][p-1] + segmentValue[j+1][i];
                    dpPred[i][p] = j;
                }
            }
        }
    }

    cout << dp[n-1][k] << '\n';
    makeAndPrint();

    memset(dp, 0, sizeof(dp));
    for(int i = 0;i<n;i++)
    {
        dp[i][1] = segmentValue[0][i];
        dpPred[i][1] = -1;
    }


    for(int i = 1;i<n;i++)
    {
        for(int p = 2;p<=k;p++)
        {
            dp[i][p] = INT_MAX;
            for(int j = i-1;j>=0;j--)
            {
                calc4Segment(j+1, i);
                if( dp[j][p-1] + segmentValue[j+1][i] < dp[i][p] )
                {
                    dp[i][p] = dp[j][p-1] + segmentValue[j+1][i];
                    dpPred[i][p] = j;
                }
            }
        }
    }

    makeAndPrint();
}
