#include<iostream>
#include<cstring>
#include<vector>
#include<queue>

using namespace std;

const int MAXN = 1e5 + 5;

int n, m, A, B;
int u, v;

int dist[MAXN];
queue <int> q;

vector <int> topSort;
vector <int> graph[MAXN], DAG[MAXN];

void BFS(int x)
{
    q.push(x);
    dist[x] = 1;

    while(q.empty()==false)
    {
        x = q.front();
        q.pop();

        for(int i = 0;i<graph[x].size();i++)
        {
            if(dist[ graph[x][i] ]==0)
            {
                dist[ graph[x][i] ] = dist[x] + 1;
                q.push(graph[x][i]);

                DAG[ graph[x][i] ].push_back( x );
                cout << graph[x][i] << " --> " << x << '\n';
            }
        }
    }
}

void DFS(int x)
{
    dist[x] = 1;

    for(int i = 0;i<DAG[x].size();i++)
    {
        if(dist[ DAG[x][i] ]==0)
        {
            DFS(DAG[x][i]);
        }
    }

    topSort.push_back(x);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> A >> B;
    for(int i = 0;i<m;i++)
    {
        cin >> u >> v;

        graph[u].push_back(v);
        graph[v].push_back(u);
    }

    BFS(B);
    memset(dist, 0, sizeof(dist));

    for(int i = 1;i<=n;i++)
    {
        if(dist[i]==0)
        {
            DFS(i);
        }
    }

    for(int i = 0;i<n;i++)
        cout << topSort[i] << '\n';
}
/*
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
