#include<iostream>
#include<vector>
#include<queue>
#include<climits>
using namespace std;

void bfs(vector<vector<int>> &v, vector<int> &dist, int &a, int &b, int &n)
{
    vector<bool> used;
    used.resize(n+1);
    used[a]=true;
    dist[a]=0;
    queue<int> q;
    q.push(a);
    while(!q.empty())
    {
        int x=q.front();
        q.pop();
        for(int i : v[x])
        {
            if(!used[i])
            {
                q.push(i);
                dist[i]=dist[x]+1;
                used[i]=true;
            }
        }
    }
}

void findPath(vector<int> &path, vector<int> &dist, vector<vector<int>> &v, int &a, int &b)
{
    int cur=b;
    path.push_back(b);
    while(cur!=a)
    {
        int m=INT_MAX, id=0;
        for(int i : v[cur])
        {
            if(dist[i]<m)
            {
                m=dist[i];
                id=i;
            }
        }
        path.push_back(id);
        cur=id;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    vector<vector<int>> v;
    vector<int> dist;
    int n,m,a,b;
    cin>>n>>m>>a>>b;
    v.resize(n+1);
    dist.resize(n+1);
    for(int i=1;i<=m;i++)
    {
        int x,y;
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    bfs(v,dist,a,b,n);
    vector<int>path;
    findPath(path, dist, v, a, b);
    vector<bool>used;
    used.resize(n+1);
    int cnt=0;
   // cout<<path[path.size()-1]<<endl;
    for(int i=1; i<path.size(); i++)
    {
        int cur=path[i-1];
        while(cur!=path[i])
        {
            used[cur]=true;
            if(v[cur].size()>2 && cur!=path[i-1])
            {
                int m=INT_MAX,id=0;
                for(int x : v[cur])
                {
                    if(dist[x]<m && !used[x])
                    {
                        m=dist[x];
                        id=x;
                    }
                }
                cur=id;
            }
            else
            {
                int m=INT_MIN,id=0;
                for(int x : v[cur])
                {
                    //cout<<x<<" ";
                    if(dist[x]>m && !used[x])
                    {
                        m=dist[x];
                        id=x;
                    }
                }
                cur=id;
            }
            cnt++;
            //cout<<cur<<endl;
            //system("pause");
        }
    }
    cout<<cnt<<endl;
    return 0;
}
/*
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
