#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 1e5 + 5;

class Graph {
public:
	class Node {
	public:
		bool isVisited;
		int id, parent, degree;
		vector< int > v;
	};

	int cntNodes;
	Node nodes[MAX_N];

	void Init(int cntNodes) {
		this->cntNodes = cntNodes;
		
		for(int i = 1; i <= cntNodes; i++) {
			nodes[i].id = i;
			nodes[i].isVisited = false;
			nodes[i].degree = 0;
		}
	}
	
	void AddEdge(int x, int y) {
		nodes[x].v.push_back(y);
		nodes[y].v.push_back(x);
	
		nodes[x].degree++;
		nodes[y].degree++;
	}

	void Bfs(int startNode, int endNode) {
		queue< int > q;

		q.push(startNode);
		nodes[startNode].isVisited = true;

		while(!q.empty()) {
			int curr = q.front();
			q.pop();

			if(curr == endNode) {
				break;
			}

			for(int x : nodes[curr].v) {
				if(!nodes[x].isVisited) {
					q.push(x);
					nodes[x].isVisited = true;
					nodes[x].parent = curr;
				}
			}
		}
	}

	void MarkAllNodesUnvisited() {
		for(int i = 1; i <= cntNodes; i++) {
			nodes[i].isVisited = false;
		}
	}

	void Dfs(int node, int &cycleSize) {
		nodes[node].isVisited = true;
		cycleSize++;

		for(int x : nodes[node].v) {
			if(!nodes[x].isVisited) {
				Dfs(x, cycleSize);
			}
		}
	}
};

Graph g;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m, a, b;
	cin >> n >> m >> a >> b;

	g.Init(n);

	for(int i = 1; i <= m; i++) {
		int x, y;
		cin >> x >> y;

		g.AddEdge(x, y);
	}

	g.Bfs(a, b);

	int curr = b;
	vector< int > shortestPath;

	while(curr != a) {
		shortestPath.push_back(curr);
		curr = g.nodes[curr].parent;
	}
	shortestPath.push_back(a);

	reverse(shortestPath.begin(), shortestPath.end());
	
	g.MarkAllNodesUnvisited();

	int sinceLastSpecial = 1, ans = 0, lastSinceLastSpecial = 0;
	for(int i = 1; i < (int) shortestPath.size(); i++) {
		if(i == shortestPath.size() - 1 || g.nodes[shortestPath[i]].degree > 2) {
			if(sinceLastSpecial== 1) {
				g.nodes[shortestPath[i - 1]].isVisited = false;		
			}

			g.nodes[shortestPath[i]].isVisited = true;

			int cycleSize = 1;
			g.Dfs(shortestPath[i - 1], cycleSize);
			
			if(i != shortestPath.size() - 1 && g.nodes[b].isVisited) {
				ans += cycleSize - (sinceLastSpecial + lastSinceLastSpecial);
				break;
			}

			ans += cycleSize - sinceLastSpecial;
		
			lastSinceLastSpecial = sinceLastSpecial;
			sinceLastSpecial = 1;
		}
		else {
			sinceLastSpecial++;
		}
	}
	
	cout << ans << endl;
	return 0;
}
