#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const short MAX_N = 1005;
const short MAX_K = 205;

bool isCalculated[MAX_N][MAX_K];
short n, k, maxSubseq[MAX_N][MAX_N], dp[MAX_N][MAX_K], parentMax[MAX_N][MAX_K], parentMin[MAX_N][MAX_K];

void ComputeDp() {
	memset(dp, -1, sizeof(dp));

	dp[0][0] = 0;
	for(short j = 1; j <= k; j++) {
		for(short i = j; i <= n; i++) {
			for(short p = i; p >= max((short) 1, j); p--) {
				short curr = dp[p - 1][j - 1];
				if(curr == -1) {
					continue;
				}
				curr += maxSubseq[p][i];

				if(dp[i][j] == -1 || curr < dp[i][j]) {
					dp[i][j] = curr;
					
					parentMin[i][j] = p;
					parentMax[i][j] = p;
				}
				else if(curr == dp[i][j]) {
					if(p > parentMax[i][j]) {
						parentMax[i][j] = p;
					}
					if(p < parentMin[i][j]) {
						parentMin[i][j] = p;
					}
				}
			}
		}
	}
}

class OutputLine {
public:
	short ind, from, en, cnt;
	vector< short > positions;

	void Prshort() {
		cout << ind << ",[" << from << "," << en << "]," << cnt << ":";
		for(short x : positions) {
			cout << x << " ";
		}
		cout << endl;
	}
};

OutputLine maxAns[MAX_K], minAns[MAX_K];
string s;

void GetMaxSubseq(short from, short to, vector< short > &v) {
	stack< short > opening;

	for(short i = from; i <= to; i++) {
		if(s[i - 1] == '(') {
			opening.push(i);
		}
		else {
			if(!opening.empty()) {
				v.push_back(opening.top());
				v.push_back(i);
				opening.pop();
			}
		}
	}

	sort(v.begin(), v.end());
}

void PrshortMax() {
	short ind = n, rem = k;

	while(rem > 0) {
		maxAns[rem].ind = rem;
		maxAns[rem].from = parentMax[ind][rem];
		maxAns[rem].en = ind;
		maxAns[rem].cnt = 2 * maxSubseq[parentMax[ind][rem]][ind];
		GetMaxSubseq(maxAns[rem].from, maxAns[rem].en, maxAns[rem].positions);

		ind = parentMax[ind][rem] - 1;
		rem--;
	}

	for(short i = 1; i <= k; i++) {
		maxAns[i].Prshort();
	}
}

void PrshortMin() {
	short ind = n, rem = k;

	while(rem > 0) {
		minAns[rem].ind = rem;
		minAns[rem].from = parentMin[ind][rem];
		minAns[rem].en = ind;
		minAns[rem].cnt = 2 * maxSubseq[parentMin[ind][rem]][ind];
		GetMaxSubseq(minAns[rem].from, minAns[rem].en, minAns[rem].positions);

		ind = parentMin[ind][rem] - 1;
		rem--;
	}

	for(short i = 1; i <= k; i++) {
		minAns[i].Prshort();
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cin >> s >> k;

	n = s.size();
	for(short i = 0; i < n; i++) {
		short cntRemOpening = 0, maxLen = 0;

		for(short j = i; j < n; j++) {
			if(s[j] == '(') {
				cntRemOpening++;
			}
			else {
				if(cntRemOpening > 0) {
					maxLen++;
					cntRemOpening--;
				}
			}

			maxSubseq[i + 1][j + 1] = maxLen;
		}
	}
	
	ComputeDp();

	short ans = 2 * dp[n][k];
	cout << ans << endl;

	PrshortMin();
	PrshortMax();

	return 0;
}
