#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 1e5 + 5;

int distTo[MAX_N];

class Graph {
public:
	class Node {
	public:
		bool isVisited;
		int id, parent, degree;
		vector< int > v;
	};

	int cntNodes;
	Node nodes[MAX_N];

	void Init(int cntNodes) {
		this->cntNodes = cntNodes;
		
		for(int i = 1; i <= cntNodes; i++) {
			nodes[i].id = i;
			nodes[i].isVisited = false;
			nodes[i].degree = 0;
		}
	}
	
	void AddEdge(int x, int y) {
		nodes[x].v.push_back(y);
		nodes[y].v.push_back(x);
	
		nodes[x].degree++;
		nodes[y].degree++;
	}

	void Bfs(int startNode, int endNode) {
		queue< int > q;

		q.push(startNode);
		nodes[startNode].isVisited = true;

		while(!q.empty()) {
			int curr = q.front();
			q.pop();

			if(curr == endNode) {
				break;
			}

			for(int x : nodes[curr].v) {
				if(!nodes[x].isVisited) {
					q.push(x);
					nodes[x].isVisited = true;
					nodes[x].parent = curr;
				}
			}
		}
	}

	void MarkAllNodesUnvisited() {
		for(int i = 1; i <= cntNodes; i++) {
			nodes[i].isVisited = false;
		}
	}
	
	void Bfs2(int node, int d, int &nxtNode) {
		queue< pair< int, int > > q;

		q.push({ node, d });
		nodes[node].isVisited = true;

		while(!q.empty()) {
			int curr = q.front().first;
			int aux = q.front().second;
			q.pop();

			if(distTo[curr] != -1) {
				distTo[curr] = max(distTo[curr], aux);
				nxtNode = curr;
				break;
			}

			for(int x : nodes[curr].v) {
				if(!nodes[x].isVisited) {
					q.push({ x, aux + 1 });
					nodes[x].isVisited = true;
				}
			}
		}
	}
};

Graph g;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m, a, b;
	cin >> n >> m >> a >> b;

	g.Init(n);

	for(int i = 1; i <= m; i++) {
		int x, y;
		cin >> x >> y;

		g.AddEdge(x, y);
	}

	g.Bfs(a, b);

	int curr = b;
	vector< int > shortestPath;

	while(curr != a) {
		shortestPath.push_back(curr);
		curr = g.nodes[curr].parent;
	}
	shortestPath.push_back(a);
	
	reverse(shortestPath.begin(), shortestPath.end());
	
	memset(distTo, -1, sizeof(distTo));
	for(int i = 0; i < shortestPath.size(); i++) {
		distTo[shortestPath[i]] = i;
	}

	g.MarkAllNodesUnvisited();
	
	int ind = 0;
	while(ind != shortestPath.size() - 1) {
		g.nodes[shortestPath[ind]].isVisited = true;
		
		int currNode = shortestPath[ind];
		for(int x : g.nodes[currNode].v) {
			if(x != shortestPath[ind + 1] && !g.nodes[x].isVisited) {
				int nxtNode = -1;
				g.Bfs2(x, distTo[currNode] + 1, nxtNode);
				
				if(nxtNode != -1) {
					while(shortestPath[ind] != nxtNode) {
						ind++;
					}
					break;
				}
			}
		}
	}
		
	cout << distTo[b] << endl;
	return 0;
}
