#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define pb push_back
#define mp make_pair
using namespace std;
const int N=1e3+5;
const int INF=1e9;

int n,k;
string s;

int dp_longest[N][200],opt_longest[N][200];
int dp_shortest[N][200],opt_shortest[N][200];

int len_correct[N][N];

void calc_len(int ind)
{
    int i;
    int opening=0,pairs=0;

    for(i=ind;i<n;i++)
    {
        if(s[i] == '(')
            opening++;
        else
        {
            if(opening)
            {
                opening--;
                pairs++;
            }
        }
        len_correct[ind][i]=pairs*2;
    }
}

void solve_longest()
{
   int i,j,l;

   for(i=0;i<n;i++)
   {
       for(j=0;j<=k;j++)
       {
           dp_longest[i][j]=INF;
       }
   }

   opt_longest[0][1]=-1;
   dp_longest[0][1]=0;
   for(i=1;i<n;i++)
   {
       for(j=0;j<i;j++)
       {
           for(l=2;l<=k;l++)
           {
               if(dp_longest[j][l-1]+len_correct[j+1][i] < dp_longest[i][l])
               {
                 dp_longest[i][l]=dp_longest[j][l-1]+len_correct[j+1][i];
                 opt_longest[i][l]=j;
               }
           }
           dp_longest[i][1]=len_correct[0][i];
           opt_longest[i][1]=-1;
       }
   }
}

void solve_shortest()
{
   int i,j,l;

   for(i=0;i<n;i++)
   {
       for(j=0;j<=k;j++)
       {
           dp_shortest[i][j]=INF;
       }
   }

   opt_shortest[0][1]=-1;
   dp_shortest[0][1]=0;
   for(i=1;i<n;i++)
   {
       for(j=i-1;j>=0;j--)
       {
           for(l=2;l<=k;l++)
           {
               if(dp_shortest[j][l-1]+len_correct[j+1][i] < dp_shortest[i][l])
               {
                 dp_shortest[i][l]=dp_shortest[j][l-1]+len_correct[j+1][i];
                 opt_shortest[i][l]=j;
               }
           }
           dp_shortest[i][1]=len_correct[0][i];
           opt_shortest[i][1]=-1;
       }
   }
}

vector <int> get_pos(int l,int r)
{
    int i;

    vector <int> temp,res;

    for(i=l;i<=r;i++)
    {
       if(s[i] == '(')
       {
           temp.emplace_back(i);
       }
       else
       {
           if(!temp.empty())
           {
               res.emplace_back(temp.back());
               res.emplace_back(i);

               temp.pop_back();
           }
       }
    }

    sort(res.begin(),res.end());
    return res;
}

struct part{

  int beg,fin;
  vector <int> pos;

  bool operator <(part other) const
  {
     return beg<other.beg;
  }

  void print()
  {
      cout<<"["<<beg+1<<","<<fin+1<<"]"<<",";
      cout<<len_correct[beg][fin]<<":";

      for(int i=0;i<pos.size();i++)
      {
          cout<<pos[i]+1<<" ";
      }
      cout<<endl;
  }

};

vector <part> longest,shortest;

void get_longest()
{
    int i=n-1,cur=k;
    int l,r;

    while(i > -1)
    {
        l=opt_longest[i][cur]+1;
        r=i;

        part temp;

        temp.beg=l;
        temp.fin=r;
        temp.pos=get_pos(l,r);

        longest.emplace_back(temp);

        i=l-1;
        cur--;
    }
}

void get_shortest()
{
    int i=n-1,cur=k;
    int l,r;

    while(i > -1)
    {
        l=opt_shortest[i][cur]+1;
        r=i;

        part temp;

        temp.beg=l;
        temp.fin=r;
        temp.pos=get_pos(l,r);

        shortest.emplace_back(temp);

        i=l-1;
        cur--;
    }
}

int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(NULL);
   cout.tie(NULL);

   int i,j;

   cin>>s;
   cin>>k;

   n=s.size();

   for(i=0;i<n;i++)
   {
       calc_len(i);
   }

   solve_longest();
   solve_shortest();

   get_longest();
   get_shortest();

   cout<<dp_longest[n-1][k]<<endl;
   reverse(longest.begin(),longest.end());
   for(i=0;i<longest.size();i++)
   {
       cout<<i+1<<",";
       longest[i].print();
   }

   reverse(shortest.begin(),shortest.end());
   for(i=0;i<shortest.size();i++)
   {
       cout<<i+1<<",";
       shortest[i].print();
   }

   return 0;
}

/**

()()
3

**/


