#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#define pb push_back
#define mp make_pair
using namespace std;
const int N=1e5+5;
const int INF=1e9;

int n,m,A,B;

int vis[N];
vector <int> nb[N];
int faces;

int ans;

vector <int> comp[N];
int sz_comp[N],components;
int rep[N];

bool in_path[N];
vector <int> path;
void DFS_simple(int v,int par=-1)
{
   vis[v]=1;
   in_path[v]=true;
   path.pb(v);

   for(int i=0;i<nb[v].size();i++)
   {
      if(in_path[nb[v][i]] && nb[v][i] != par)
      {
         components++;
         int j=(int)path.size()-1;
         while(1)
         {
             comp[path[j]].pb(components);
             rep[components]=path[j];

             sz_comp[components]++;
             if(path[j] == nb[v][i])
                break;
             j--;
         }
      }

      if(!vis[nb[v][i]])
        DFS_simple(nb[v][i],v);
   }

   path.pop_back();
   in_path[v]=false;
}

set <int> s[N];
set <int>::iterator it;

struct edge{
 int v;
 int via;

};
vector <edge> comp_nb[N];


int timestamp;
int distA[N],distB[N];
void DFS_Adist(int v,int cur_comp,int len,int parent=-1)
{
  distA[v]=max(len,sz_comp[cur_comp]-len);
  vis[v]=timestamp;

  for(int i=0;i<nb[v].size();i++)
  {
      if(vis[nb[v][i]] == timestamp)
        continue;

      if(s[nb[v][i]].find(cur_comp) != s[nb[v][i]].end())
          DFS_Adist(nb[v][i],cur_comp,len+1,v);
  }
}

void DFS_Bdist(int v,int cur_comp,int len,int parent=-1)
{
  distB[v]=max(len,sz_comp[cur_comp]-len);
  vis[v]=timestamp;

  for(int i=0;i<nb[v].size();i++)
  {
      if(vis[nb[v][i]] == timestamp)
        continue;

      if(s[nb[v][i]].find(cur_comp) != s[nb[v][i]].end())
          DFS_Bdist(nb[v][i],cur_comp,len+1,v);
  }
}

vector <int> comp_path;
vector <int> mirror_path;
bool stopit=false;
void DFS_comp_path(int v,int via)
{
    vis[v]=timestamp;
    comp_path.pb(via);
    mirror_path.pb(v);

    if(s[B].find(v) != s[B].end())
    {
        stopit=true;
        return;
    }


    for(int i=0;i<comp_nb[v].size();i++)
    {
        if(stopit)
            return;
        if(vis[comp_nb[v][i].v] != timestamp)
         DFS_comp_path(comp_nb[v][i].v,comp_nb[v][i].via);
    }

    if(!stopit)
    {
     comp_path.pop_back();
     mirror_path.pop_back();
    }
}

int get_res(int len,int sz)
{
    if(len == 0)
        return 0;

    return max(len,sz-len);
}

void DFS_solve(int v,int at,int len)
{
   int i;

   vis[v]=timestamp;

   if(at == comp_path.size())
    return;

   for(i=0;i<nb[v].size();i++)
   {
       if(vis[nb[v][i]] == timestamp)
        continue;

       if(nb[v][i] == comp_path[at+1])
       {
           ans+=get_res(len+1,sz_comp[mirror_path[at]]);

       //    cerr<<"HERE"<<v<<" "<<comp_path[at+1]<<" "<<get_res(len+1,sz_comp[mirror_path[at]])<<endl;

           DFS_solve(nb[v][i],at+1,0);
       }
       else
       {
           DFS_solve(nb[v][i],at,len+1);
       }
   }
}

int main()
{
   int i,j,k;
   int u,v;

   scanf("%d%d%d%d", &n, &m, &A, &B);
   for(i=1;i<=m;i++)
   {
       scanf("%d%d", &u, &v);
       nb[u].pb(v);
       nb[v].pb(u);
   }

   faces=2+m-n;
   faces--;

   DFS_simple(1);

  /* for(i=1;i<=n;i++)
   {
       cerr<<i<<": ";
       for(j=0;j<comp[i].size();j++)
       {
           cerr<<comp[i][j]<<" ";
       }
       cerr<<endl;
   }*/

   for(i=1;i<=n;i++)
   {
       for(j=0;j<comp[i].size();j++)
       {
           s[i].insert(comp[i][j]);
       }
   }


   for(i=1;i<=n;i++)
   {
       for(j=0;j<comp[i].size();j++)
       {
           for(k=j+1;k<comp[i].size();k++)
           {
               edge temp;
               temp.via=i;

               temp.v=comp[i][k];
               comp_nb[comp[i][j]].pb(temp);

               temp.v=comp[i][j];
               comp_nb[comp[i][k]].pb(temp);

           }
       }
   }

  /* for(i=1;i<=components;i++)
   {
       cerr<<i<<": ";
       for(j=0;j<comp_nb[i].size();j++)
       {
           cerr<<comp_nb[i][j].v<<" ";
       }
       cerr<<endl;
   }*/

   timestamp=3;
   for(i=0;i<comp[A].size();i++)
   {
       timestamp++;
       DFS_Adist(A,comp[A][i],0);
   }
   distA[A]=0;

   for(i=0;i<comp[B].size();i++)
   {
       timestamp++;
       DFS_Bdist(B,comp[B][i],0);
   }
   distB[B]=0;

   for(i=0;i<comp[A].size();i++)
   {
       timestamp++;
       if(!stopit)
       {
           DFS_comp_path(comp[A][i],A);
       }
   }

   if(comp_path.back() != B)
    comp_path.pb(B);

    timestamp++;
   DFS_solve(A,0,0);



   printf("%d \n", ans);



   return 0;
}

/*

10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1

*/
