#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ull unsigned long long
#define X first
#define Y second

using pii = std::pair<int, int>;
using pll = std::pair<ll, ll>;

#define _ << " " <<
#define debug(x) #x << " = " << (x)

const int maxn = 1e5+10;
vector<int> tree[maxn], v[maxn];
stack<int> st;

int viz[maxn], in_stack[maxn];

vector<int> component[maxn];
vector<int> in_component[maxn];
int n_comp = 0;

void addedge(int x, int y)
{
    v[x].push_back(y);
    v[y].push_back(x);
}

int remain[maxn];

void cdfs(int x, int par = -1)
{
    if (viz[x]) return;
    if (in_stack[x])
    {
 //       cout << "cycle " << debug(x) << " ";
        int c = n_comp;
        std::vector<int> to_return;
        while(st.top() != x)
        {
  //          cout << st.top() << " ";
            component[st.top()].push_back(c);
            in_component[c].push_back(st.top());

            if (remain[st.top()] < v[st.top()].size())
                to_return.push_back(st.top());

            st.pop();

            if (st.empty())
            {
                cout << "wa" << endl;
                exit(0);
            }
        }

        for (int i : to_return)
            st.push(i);

        in_component[c].push_back(x);
        component[x].push_back(c);
        ++n_comp;

   //     cout << endl;

        return;
    }

    st.push(x);
    in_stack[x] = 1;

    for (auto y : v[x])
    {
        ++remain[x];
        if(y != par)
        {
//            cout << debug(y) _ debug(x) _ debug(par) << endl;
            cdfs(y, x);
        }
    }

    viz[x] = 1;
}

int viz2[maxn];
vector<int> path;

int get_same(int x, int y)
{
    std::set<int> ix;
    for (auto c: component[x]) ix.insert(c);
    for (auto c : component[y]) if (ix.count(c)) return c;

    return -1;
}

void find_path(int x, int b)
{
    viz2[x] = 1;
    path.push_back(x);

    if (b == x) 
        return;

    for (auto y : v[x])
    {
        if (viz2[y]) continue;
        find_path(y, b);
        if (path.back() == b)
            return;
    }

    path.pop_back();
}

int main()
{
    ios::sync_with_stdio(false);

    int n, m, a, b;
    cin >> n >> m >> a >> b;

    for (int i = 0;i < m; i++)
    {
        int x, y;
        cin >> x >> y;
        addedge(x, y);
    }

    cdfs(1);

        find_path(a, b);
    //for (int i : path) cout << debug(i) << endl;

    std::vector<int> critical;
    critical.push_back(path[0]);
    for (size_t i = 1; i < path.size() - 1; i++)
    {
        int c1 = get_same(path[i - 1], path[i]);
        int c2 = get_same(path[i], path[i + 1]);
        if (c1 != c2)
            critical.push_back(path[i]);
    }
    critical.push_back(path.back());


   // for (int i : critical)
    //    cout << i << endl;


    int dist = 0;
    for (size_t i = 1; i < critical.size(); i++)
    {
        int c = get_same(critical[i], critical[i - 1]);

        int i1, i2;

        for (size_t j = 0; j < in_component[c].size(); j++)
        {
            if (in_component[c][j] == critical[i]) i1 = j;
            if (in_component[c][j] == critical[i - 1]) i2 = j;
        }

        if (i1 > i2) std::swap(i1, i2);
        dist += std::max(i2 - i1, (int)in_component[c].size() - (i2 - i1));

    }

    cout << dist << endl;

    return 0;
}
