#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ull unsigned long long
#define X first
#define Y second

using pii = std::pair<int, int>;
using pll = std::pair<ll, ll>;

#define _ << " " <<
#define debug(x) #x << " = " << (x)

const int maxn = 1024;
const int maxk = 201;

struct option
{
    int value;
    int begin, end;

    int first;
    int match;
};

bool operator < (const option& a, const option &b)
{
 //   cout << debug(a.value) _ debug(b.value) _ debug(a.end) _ debug(b.end) _ debug(a.begin) _ debug(b.begin) << endl;
    if (a.value == b.value)
    {
        if (a.end == b.end)
            return a.begin < b.begin;

        return a.end > b.end;
    }

    return a.value < b.value;
}

option dp[maxn][maxn];

int part[maxn][maxk];

void recover_data(int i, int j)
{
    if (i >= j || dp[i][j].value == 0)
        return;

    std::cout << dp[i][j].first + 1 <<" ";
    recover_data(dp[i][j].first + 1, dp[i][j].match - 1);
    cout << dp[i][j].match + 1 << " ";
    recover_data(dp[i][j].match + 1, j);
}

int main()
{
    ios::sync_with_stdio(false);

    string in;
    cin >> in;
    int k; cin >> k;


    int n = in.length();
    for (int i = 0; i < n; i++)
    {
        dp[i][i] = {0, 0, 0};
    }

    for (int d = 1; d <= n - 1; d++)
    {
        for (int i = 0; i + d < n; i++)
        {
            int j = i + d;

//cout<< debug(i) _ debug(j) << endl;
            dp[i][j] = dp[i + 1][j];
            if (in[i] == '(')
            {
                for (int k = i + 1; k <= j; k++)
                {
                    if (in[k] == ')')
                    {

#define has_ending ((k < j - 1 and dp[k + 1][j].value > 0))

                        if (k == i + 1 && !has_ending)
                        {
                            dp[i][j] = std::max(dp[i][j], option{1, i, k, i, k});
                        } else if (k == i + 1)
                        {
                            dp[i][j] = std::max(dp[i][j],
                                    option{1 + dp[k + 1][j].value, dp[k + 1][j].begin, dp[k + 1][j].end, i, k});
                        } else if (!has_ending)
                        {
                            dp[i][j] = std::max(dp[i][j],
                                    option{1 + dp[i + 1][k - 1].value, i, k, i, k});
                        } else
                        {
                            dp[i][j] = std::max(dp[i][j],
                                    option{1 + dp[i + 1][k - 1].value + dp[k + 1][j].value,
                                    dp[k + 1][j].begin, dp[k + 1][j].end, i, k});
                        }
                    }
                }
            }
        }
    }

    /*
    for (int i = 0; i < n; i++)
    {
        for (int j = i; j < n; j++)
        {
            std::cout << debug(i) _ debug(j) _ debug(dp[i][j].value) << endl;
        }
    } */

    std::memset(part, 0x3f, sizeof(part));
    for (int i = 0; i < n; i++)
    {
        part[i][1] = dp[0][i].value;
        for (int j = 2; j <= k; j++)
        {
            for (int p = 0; p < i; p++)
            {
                part[i][j] = std::min(part[i][j], part[p][j - 1] + dp[p + 1][i].value);
            }
        }
    }

    int best = part[n - 1][k];
    cout << best * 2 << "\n";

    int j = n - 1;

    std::vector<pii> ans1;
    int p = k;
    int prefix = 0;

    while(j >= 0)
    {
        int i = p - 1;
        for (; i <= j; i++)
        {
            if (prefix + part[i - 1][p - 1] + dp[i][j].value <= best)
                break;
        }
        
        if (i > j) --i;
        ans1.push_back({i, j});
        prefix += dp[i][j].value;

        j = i - 1;
        --p;
    }

    int id = 1;
    for (int i = ans1.size() - 1; i >= 0; i--)
    {
        int a = ans1[i].X, b = ans1[i].Y;
        std::cout << id++ << ",[" << a + 1 << "," << b + 1 << "]," << dp[a][b].value * 2 << ":";
        recover_data(a, b);
        cout << "\n";
    }

    ans1.clear();
    const int inf = 0x3f3f3f3f;

    j = n - 1;
    p = k;
    prefix = 0;
    while(j >= 0)
    {
        int i = j;
        for (; i >= p - 1; i--)
        {
            if (prefix + part[i - 1][p - 1] + dp[i][j].value <= best)
                break;
        }
        
        ans1.push_back({i, j});
        prefix += dp[i][j].value;

        j = i - 1;
        --p;
    }

    id = 1;
    for (int i = ans1.size() - 1; i >= 0; i--)
    {
        int a = ans1[i].X, b = ans1[i].Y;
        std::cout << id++ << ",[" << a + 1 << "," << b + 1 << "]," << dp[a][b].value * 2 << ":";
        recover_data(a, b);
        cout << "\n";
    }

    return 0;
}
