#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ull unsigned long long
#define X first
#define Y second

using pii = std::pair<int, int>;
using pll = std::pair<ll, ll>;

#define _ << " " <<
#define debug(x) #x << " = " << (x)

const int maxn = 1e5+10;
vector<int> v[maxn];

stack<int> st;

int viz[maxn];

vector<int> component[maxn];
vector<int> in_component[maxn];

void addedge(int x, int y)
{
    v[x].push_back(y);
    v[y].push_back(x);
}

int work[maxn];
std::deque<int> current;

int simple_cycle(int x, int par = -1, int d = 0)
{
    if (viz[x]) return -1;
    if (v[x].size() - work[x] > 2)
        return x;

    int y1 = -1, y2 = -1;
    for (int y : v[x])
    {
        if (!viz[y])
        {
            if (y1 == -1)
                y1 = y;
            else
                y2 = y;
        }
    }

    //cout << debug(x) _ debug(par) _ debug(y1) _ debug(y2) << endl;

    if (par == -1)
    {
        current.push_back(x);
        viz[x] = 1;

        if (y2 > 0)
        {
            simple_cycle(y1, x, 0);
            return simple_cycle(y2, x, 1);
        } else
        {
            return simple_cycle(y1, x, 0);
        }
    }

    viz[x] = 1;

    if (d)current.push_front(x);
    else current.push_back(x);

    if (y1 == -1)
        return -1;

    return simple_cycle(y1, x, d);
}

void reduce_cycles(int n)
{
    std::queue<int> simple;
    for (int i = 1; i <= n; i++)
    {
        if (v[i].size() == 2)
            simple.push(i);
    }

    int c = 0;
    while(simple.size())
    {
        int x = simple.front(); simple.pop();

    //    cout << "try" _ debug(x) << endl;

        if (work[x] == v[x].size())
            continue;

        current.clear();
        int k = simple_cycle(x);
        if (k > 0) current.push_back(k);

        std::vector<int>& cycle = in_component[c];
   //     cout << "cycle:";
        for (auto i : current)
        {
  //          cout _ i;
            work[i] += 2;
            cycle.push_back(i);
            component[i].push_back(c);
        }
 //       cout << endl;
        c++;

//        cout << debug(k) _ debug(work[k]) _ debug(v[k].size()) << endl;
        if (k > 0 && work[k] + 2 == v[k].size())
            simple.push(k);
    }
}

int viz2[maxn];
vector<int> path;

int get_same(int x, int y)
{
    std::set<int> ix;
    for (auto c: component[x]) ix.insert(c);
    for (auto c : component[y]) if (ix.count(c)) return c;

    return -1;
}

void find_path(int x, int b)
{
    viz2[x] = 1;
    path.push_back(x);

    if (b == x) 
        return;

    for (auto y : v[x])
    {
        if (viz2[y]) continue;
        find_path(y, b);
        if (path.back() == b)
            return;
    }

    path.pop_back();
}

int main()
{
    ios::sync_with_stdio(false);

    int n, m, a, b;
    cin >> n >> m >> a >> b;

    for (int i = 0;i < m; i++)
    {
        int x, y;
        cin >> x >> y;
        addedge(x, y);
    }

    reduce_cycles(n);

    find_path(a, b);
    //for (int i : path) cout << debug(i) << endl;

    std::vector<int> critical;
    critical.push_back(path[0]);
    for (size_t i = 1; i < path.size() - 1; i++)
    {
        int c1 = get_same(path[i - 1], path[i]);
        int c2 = get_same(path[i], path[i + 1]);
        if (c1 == -1  || c2 == -1)
        {
            int *p = 0;
            *p = 1;
        }
        if (c1 != c2)
            critical.push_back(path[i]);
    }
    critical.push_back(path.back());


   // for (int i : critical)
    //    cout << i << endl;


    int dist = 0;
    for (size_t i = 1; i < critical.size(); i++)
    {
        int c = get_same(critical[i], critical[i - 1]);

        int i1, i2;

        for (size_t j = 0; j < in_component[c].size(); j++)
        {
            if (in_component[c][j] == critical[i]) i1 = j;
            if (in_component[c][j] == critical[i - 1]) i2 = j;
        }

        if (i1 > i2) std::swap(i1, i2);
        dist += std::max(i2 - i1, (int)in_component[c].size() - (i2 - i1));

    }

    cout << dist << endl;

    return 0;
}
