#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <cstdlib>
using namespace std;


vector < pair < int, int > > arr;

int cross( pair < int, int > a, pair < int, int > b, pair < int, int > c ) {
    a.first -= b.first;
    c.first -= b.first;
    a.second -= b.second;
    c.second -= b.second;
    return a.first*c.second - a.second*c.first;
}
bool cmp ( pair < int , int > a, pair < int, int > b ) {
    return cross( a, arr[0], b ) < 0;
}

vector < pair < int, int > > hull;
int chSize ( ) {
    hull.clear();
    int minInd = 0;
    for ( int i = 1 ; i < arr.size() ; i ++ ) {
        if ( arr[i].first < arr[ minInd ].first ) {
            minInd = i;
        }else if ( arr[i].first == arr[ minInd ].first && arr[i].second < arr[ minInd ].second ) {
            minInd = i;
        }
    }
    swap( arr[0], arr[minInd] );
    sort( arr.begin()+1, arr.end(), cmp );

    for ( int i = 0 ; i < arr.size() ; i ++ ) {
  //      cout << arr[i].first << " " << arr[i].second << "\n";
    }
  //  cout << "\n";

    hull.push_back( arr[0] );
    hull.push_back( arr[1] );
    for ( int i = 2 ; i < arr.size() ; i ++ ) {
        for ( ; hull.size() > 2 && cross( hull[ hull.size()-2], hull.back(), arr[i] ) <= 0 ; hull.pop_back() ) {  }
        hull.push_back( arr[i] );
    }

    for ( int i = 0 ; i < hull.size() ; i ++ ) {
 //       cout << hull[i].first << " " << hull[i].second << "\n";
    }
    return hull.size();
}

pair < int, int > g ( pair < int, int > a, pair < int, int > b ) {
    pair < int, int > ret;
    ret.first = a.first + (b.first-a.first)*2;
    ret.second = a.second + (b.second-a.second)*2;
    return ret;
}
vector < pair < int, int > > ans;

int main () {
    srand(69);

    int n;
    cin >> n;
    for ( int i = 0 ; i < n ; i ++ ) {
        int a, b;
        cin >> a >> b;
        arr.push_back( make_pair( a, b ) );
    }

    for ( int i = 0 ; i < 1000000 ; i ++ ) {
        if ( chSize() == n ) { break;}

        int h = rand()%n, j = rand()%n;
        if ( h == j ) { continue; }

        arr[h] = g( arr[h], arr[j] );
        ans.push_back( make_pair(h,j) );
    }

    cout << ans.size() << "\n";

    for ( int i = 0 ; i < ans.size() ; i ++ ) {
        cout << ans[i].first+1 << " " << ans[i].second+1 << "\n";
    }
    return 0;
}
/*
4
0 0
2 0
0 1
1 1


6
3 5
4 3
3 1
11 4
7 7
7 2

*/
