#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <cstdlib>
#include <queue>
using namespace std;

vector < pair < int, int > > arr;

int cross( pair < int, int > a, pair < int, int > b, pair < int, int > c ) {
    a.first -= b.first;
    c.first -= b.first;
    a.second -= b.second;
    c.second -= b.second;
    return a.first*c.second - a.second*c.first;
}
bool cmp ( pair < int , int > a, pair < int, int > b ) {
    return cross( a, arr[0], b ) < 0;
}

vector < pair < int, int > > hull;
vector < pair < int, int > > ccc;
int chSize ( ) {
    hull.clear();
    ccc = arr;
    int minInd = 0;
    for ( int i = 1 ; i < arr.size() ; i ++ ) {
        if ( arr[i].first < arr[ minInd ].first ) {
            minInd = i;
        }else if ( arr[i].first == arr[ minInd ].first && arr[i].second < arr[ minInd ].second ) {
            minInd = i;
        }
    }
    swap( arr[0], arr[minInd] );
    sort( arr.begin()+1, arr.end(), cmp );

    for ( int i = 0 ; i < arr.size() ; i ++ ) {
  //      cout << arr[i].first << " " << arr[i].second << "\n";
    }
  //  cout << "\n";

    hull.push_back( arr[0] );
    hull.push_back( arr[1] );
    for ( int i = 2 ; i < arr.size() ; i ++ ) {
        for ( ; hull.size() > 2 && cross( hull[ hull.size()-2], hull.back(), arr[i] ) <= 0 ; hull.pop_back() ) {  }
        hull.push_back( arr[i] );
    }
    arr = ccc;
    return hull.size();
}

pair < int, int > g ( pair < int, int > a, pair < int, int > b ) {
    pair < int, int > ret;
    ret.first = a.first + (b.first-a.first)*2;
    ret.second = a.second + (b.second-a.second)*2;
    return ret;
}
vector < pair < int, int > > ans, st;

map < vector < pair < int, int > >, pair < pair< int, int>, pair < int, int >  > > prop;
priority_queue < pair < int, vector < pair < int , int > > > > q;

int main () {
    srand(42);

    int n;
    cin >> n;
    for ( int i = 0 ; i < n ; i ++ ) {
        int a, b;
        cin >> a >> b;
        arr.push_back( make_pair( a, b ) );
    }
    sort( arr.begin(), arr.end() );
    st = arr;

    prop[ st ] = make_pair( make_pair(-1,-1), make_pair(-1,-1) );
    q.push( make_pair( chSize(), st ) );

    for ( int i = 0 ; arr.size()*i < 300000 ; i ++ ) {
        arr = q.top().second;
        q.pop();

        sort( arr.begin(), arr.end() );

        if ( chSize() == n ) { break; }

        vector < pair < int, int > > maxx, crr = arr, cop = arr;
        int maxSz = 0;
        pair < int, int > maxop;

        for ( int ck = 0 ; ck < 20; ck ++ ) {
            int h = rand()%n, j = rand()%n;
            if ( h == j ) { continue; }

            crr[h] = g( crr[h], crr[j] );

            arr = crr;
            if ( chSize() > maxSz ) {
                maxSz = chSize();
                maxx = arr;
                maxop = make_pair( h, j );
            }
            //q.push( make_pair( chSize(), arr ) );
            arr = cop;

            crr[h] = g( crr[h], crr[j] );
        }
        arr = maxx;
        ans.push_back( maxop );
        q.push( make_pair( chSize(), arr ) );

    }
    cout << ans.size() << "\n";

    for ( int i = 0 ; i < ans.size() ; i ++ ) {
        cout << ans[i].first+1 << " " << ans[i].second+1 << "\n";
    }
    return 0;
}
/*
4
0 0
2 0
0 1
1 1


10
1 1
32 31
17 99
42 69
3 5
4 3
3 1
11 4
7 7
7 2

*/
