#include <iostream>
#include <cstdio>
#include <vector>
#include <cstring>
using namespace std;

const int N=(1e5)+5;
const int LIMIT=20000;

vector <int> g[N],cp,p[N],polygon[LIMIT];
vector < pair <int,int> > conn[N],path;
int used[N];
int inorder[N],order[LIMIT][LIMIT];
int cycle,in,iter;
int n,m,a,b;

void DFS(int v,int prev)
{
 int i,j,num;

 used[v]=iter;
 cp.push_back(v);
 in++;
 inorder[v]=in;

  for(i=0;i<g[v].size();i++)
  {
   if(used[g[v][i]]!=iter)
    DFS(g[v][i],v);
   else
   {
    if(g[v][i]!=prev && inorder[g[v][i]]<inorder[v])
    {
     cycle++;
     num=0;

      for(j=cp.size()-1;j>=0;j--)
      {
       p[cp[j]].push_back(cycle);
       polygon[cycle].push_back(cp[j]);
       num++;
       order[cycle][cp[j]]=num;

        if(cp[j]==g[v][i])
         break;
      }
    }
   }
  }

 cp.pop_back();
}

int ans,inda,indb;

int FindDist(int cc,int curpoint,int prevpoint)
{
 int dist,sz;

 sz=polygon[cc].size();
 dist=order[cc][curpoint]-order[cc][prevpoint];
 dist=abs(dist);

  if(dist==0)
   return dist;

 dist=max(dist,sz-dist);
 return dist;
}

void GetDistance()
{
 int i,cc,curpoint,prevpoint,sum,sz,dist;


 /*cout<<"-----------------";
  for(i=0;i<path.size();i++)
   cout<<path[i].first<<" "<<path[i].second<<endl;*/

 sum=0;
  for(i=1;i<path.size();i++)
  {
   cc=path[i].first;
   curpoint=path[i].second;
   prevpoint=path[i-1].second;
   sum+=FindDist(cc,curpoint,prevpoint);
  }

  if(!path.empty())
  {
   cc=path[0].first;
   curpoint=path[0].second;
   prevpoint=a;
   sum+=FindDist(cc,curpoint,prevpoint);

   cc=p[b][indb];
   curpoint=b;
   prevpoint=path.back().second;
   sum+=FindDist(cc,curpoint,prevpoint);
  }
  else
  {
   cc=p[b][indb];
   curpoint=b;
   prevpoint=a;
   sum+=FindDist(cc,curpoint,prevpoint);
  }

  ans=max(ans,sum);
}

int GetLimit(int i)
{
 int limit;
 int sz=p[i].size();

  if(n<=20)
  {
   limit=min(sz,20);
   return limit;
  }

  if(n<=100)
  {
   limit=min(sz,3);
   return limit;
  }

 limit=min(sz,2);
 return limit;
}

void Go(int v,int prev)
{
 int i,z,limit,sz;

 limit=GetLimit(b);
  for(z=0;z<limit;z++)
  {
   if(v==p[b][z])
   {
    indb=z;
    GetDistance();
    return;
   }
  }

  for(i=0;i<conn[v].size();i++)
  {
   if(conn[v][i].first!=prev)
   {
      path.push_back(make_pair(v,conn[v][i].second));
      Go(conn[v][i].first,v);
      path.pop_back();
   }
  }
}

int main()
{

int u,v,i,j,k,limit,sz;

scanf("%d%d%d%d",&n,&m,&a,&b);

 for(i=1;i<=m;i++)
 {
  scanf("%d%d",&u,&v);
  g[u].push_back(v);
  g[v].push_back(u);
 }

iter++;
DFS(a,0);

 for(i=1;i<=n;i++)
 {
  if(p[i].size()>=2)
  {
   limit=GetLimit(i);

   for(j=0;j<limit;j++)
    for(k=j+1;k<limit;k++)
    {
     conn[p[i][j]].push_back(make_pair(p[i][k],i));
     conn[p[i][k]].push_back(make_pair(p[i][j],i));
    }
  }
 }

limit=GetLimit(a);
 for(i=0;i<limit;i++)
  Go(p[a][i],0);

printf("%d\n",ans);

return 0;
}
