#include <iostream>
#include <vector>
#include <queue>
#include <unordered_set>
#include <list>
using namespace std;

using Graph = vector<list<int>>;
Graph g;

void inp(int n, int m)
{
    g.resize(n);
    int from, to;
    while(m--)
    {
        cin >> from >> to;
        g[from-1].push_back(to-1);
        g[to-1].push_back(from-1);
    }
}

int dijkstra(int from, int to)
{
    queue<int> q;
    unordered_set<int> prev;
    vector<int> dist(g.size());
    vector<bool> f(g.size());
    dist[from]=0;
    q.push(0);
    while(!q.empty())
    {
        int u=q.front();
        q.pop();
        for(int v: g[u])
        {
            if(!f[v] && dist[v]<dist[u]+1)
                if(prev.insert(u).second)
                {
                    dist[v]=dist[u]+1;
                    q.push(v);
                }
        }
        f[u]=true;
    }
//for(auto&& i: prev) cout << i+1 << ' ';
//cout << endl;
    return dist[to];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m,a,b;
    cin >> n >> m >> a >> b;
    inp(n,m);
    cout << dijkstra(a-1,b-1) << endl;
}

/**
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
