#include <iostream>
#include <string>
#include <stack>
#include <vector>
#include <algorithm>
using namespace std;

vector<int> Good(const string& s, int from, int to)
{
    vector<int> res;
    stack<pair<char,int>> st;
    for(int i=from; i<=to; ++i)
        if(s[i]=='(') st.emplace('(',i);
        else if(!st.empty() && st.top().first=='(')
        {
            res.push_back(st.top().second);
            res.push_back(i);
            st.pop();
        }
    return res;
}

string s;

struct Braces
{
    vector<int> a;
    vector<vector<int>> v;
    int sum;
    Braces(const vector<int>& a, const string& s): a(a)
    {
        int i=0;
        //this->a.push_back(s.size()-1);
        for(int x: a)
        {
            v.push_back(Good(s,i,x));
            sum+=v.back().size();
            i=x+1;
        }
        v.push_back(Good(s,i,s.size()-1));
        sum+=v.back().size();
    }
    bool operator<(const Braces& b) const
    {
        if(sum!=b.sum) return sum<b.sum;
        for(int i=v.size()-1; i>=0; --i)
            if(v[i].size()!=b.v[i].size()) return v[i].size()<b.v[i].size();
        return true;
    }
    bool operator>(const Braces& b) const
    {
        if(sum!=b.sum) return sum<b.sum;
        for(int i=v.size()-1; i>=0; --i)
            if(v[i].size()!=b.v[i].size()) return v[i].size()>b.v[i].size();
        return true;
    }
    void print() const
    {
        int p=0;
        for(int i=0; i<v.size(); ++i)
        {
            cout << i+1 << ",[" << p+1 << ',';
            if(i!=v.size()-1) {cout << a[i]+1; p=a[i]+1;}
            else cout << s.size();
            cout << "]," << v[i].size() << ':';
            for(int x: v[i]) cout << x+1 << ' ';
            cout << endl;
        }
    }
};

bool nextComb(vector<int>& a, int n)
{
    int k=a.size();
    for(int i=k-1; i>=0; --i)
        if(a[i]<n-k+i)
        {
            ++a[i];
            for(++i; i<k; ++i) a[i]=a[i-1]+1;
            return true;
        }
    return false;
}

int main()
{
    int k;
    cin >> s >> k;
    vector<int> a(k-1);
    for(int i=0; i<k; ++i) a[i]=i;
    vector<Braces> res;
    do
    {
        /*for(int i: a) cout << i << ' ';
        cout << endl;*/
        res.emplace_back(a,s);
    }
    while(nextComb(a,s.size()-1));
    sort(res.begin(),res.end(),greater<Braces>{});
    cout << res.front().sum << endl;
    /*for(auto&& i: res)
    {
        i.print();
        cout << "-----------\n";
    }*/
    res.back().print();
    sort(res.begin(),res.end());
    res.front().print();
    //auto t=Good(s,0,s.size()-1);
    //for(auto&& i: t) cout << i << ' ';
}
