#include <iostream>
#include <vector>
#include <queue>
#include <list>
#include <set>
using namespace std;

using Graph = vector<list<int>>;
Graph g;

void inp(int n, int m)
{
    g.resize(n);
    int from, to;
    while(m--)
    {
        cin >> from >> to;
        g[from-1].push_back(to-1);
        g[to-1].push_back(from-1);
    }
}

set<int> path;

void print(const vector<int>& p, int to)
{
    if(p[to]==-1)
    {
        path.insert(to);
        //cout << to+1;
        return;
    }
    print(p,p[to]);
    path.insert(to);
    //cout << ' ' << to+1;
}

int dijkstra(int from, int to)
{
    queue<int> q;
    vector<int> prev(g.size(),-1);
    vector<int> dist(g.size(),1000000);
    vector<bool> f(g.size());
    dist[from]=0;
    q.push(from);
    while(!q.empty())
    {
        int u=q.front();
        q.pop();
        for(int v: g[u])
        {
            if(!f[v] && dist[v]>dist[u]+1)
            {
                dist[v]=dist[u]+1;
                prev[v]=u;
                q.push(v);
            }
        }
        f[u]=true;
    }
print(prev,to);
/*cout << endl;
for(int i=0; i<dist.size(); ++i) cout << from+1 << " -> " << i+1 << " = " << dist[i] << endl;*/
    return dist[to];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m,a,b;
    cin >> n >> m >> a >> b;
    inp(n,m);
    int res=m-dijkstra(a-1,b-1);
    for(int i=0; i<n; ++i)
        if(g[i].size()>2 && path.find(i)==path.end()) res-=3;
    cout << res << endl;
}

/**
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
