#include <iostream>
#include <algorithm>
using namespace std;
struct point
{
    int x,y;
    int num;
};
const int maxN=10010;
int n,m;
int s;
int ch[100010][2];
point p[maxN];
point h[maxN];
int cnt;
int ori(point a,point b,point c)
{
    int d=(a.x-b.x)*(a.y-c.y)-(a.y-b.y)*(a.x-c.x);
    if(d==0)
        return 0;
    if(d<0)
        return -1;
    return 1;
}
int dist(point a)
{
    return (p[0].x-a.x)*(p[0].x-a.x)+(p[0].y-a.y)*(p[0].y-a.y);
}
bool cmp(point a,point b)
{
    int q=ori(p[0],a,b);
    if(q==0)
        return dist(a) < dist(b);
    return q>0;
}
void convexHull(point p[],int m)
{
    int i,ind=0;
    for(i=1; i<n; i++)
    {
        if(p[i].x<p[ind].x || (p[i].x==p[ind].x && p[i].y<p[ind].y))
            ind=i;
    }
    swap(p[0],p[ind]);
    sort(p+1,p+n,cmp);
    h[0]=p[0];
    h[1]=p[1];
    cnt=2;
    for(i=2; i<n; i++)
    {
        while(cnt>=2 && ori(h[cnt-2],h[cnt-1],p[i])<=0)
            cnt--;
        h[cnt++]=p[i];
    }
}
bool check()
{
    convexHull(p,n);
    if(cnt==n)
        return 1;
    return 0;
}
point symetric(point a,point b)
{
    int difx=a.x-b.x;
    int dify=a.y-b.y;
    point t;
    t.x=a.x+difx;
    t.y=a.y+dify;
    return t;
}
bool checkOri(int ind,point t)
{
    for(int i=1; i<ind; i++)
    {
        if(ori(p[i-1],p[i],t)==-1)
            return 0;
    }
    return 1;
}
int main()
{
    int i,j;
    cin>>n;
    for(i=0; i<n; i++)
    {
        cin>>p[i].x>>p[i].y;
        p[i].num=i+1;
    }
    if(check()==1)
    {
        cout<<0<<endl;
        return 0;
    }
    if(ori(p[0],p[1],p[2])<0)
    {
        p[2]=symetric(p[1],p[2]);
        ch[s][0]=2;
        ch[s][1]=1;
        s++;
    }
    for(i=3; i<n; i++)
    {
        if(ori(p[i-2],p[i-1],p[i])<0)
        {
            for(j=0; j<n; j++)
            {
                if(i==j)
                    continue;
                point tmp=symetric(p[j],p[i]);
                if(checkOri(i,tmp)==1)
                {
                    p[i]=tmp;
                    ch[s][0]=i;
                    ch[s][1]=j;
                    s++;
                }
            }
        }
    }
    for(i=0; i<3; i++)
    {
        if(ori(p[n+i-2],p[n+i-1],p[i])<0)
        {
            for(j=0; j<n; j++)
            {
                if(i==j)
                    continue;
                point tmp=symetric(p[j],p[i]);
                if(checkOri(n,tmp)==1)
                {
                    p[i]=tmp;
                    ch[s][0]=i;
                    ch[s][1]=j;
                    s++;
                }
            }
        }
    }
    cout<<s<<endl;
    for(i=0; i<s; i++)
    {
        cout<<ch[i][0]+1<<" "<<ch[i][1]+1<<endl;
    }
    return 0;
}
/**
6
3 5
4 3
3 1
11 4
7 7
7 2
*/
