#include<iostream>
#include<vector>
#include<queue>
using namespace std;

const int MAX_N=100100;

struct Edge
{
    int f,t;
    bool inTree;
    int ind1,ind2;
};
struct Edge2
{
    int t;
    int cycle;
    bool inTree;
    int indrev;
};

vector<Edge2> ne[MAX_N];
vector<Edge> e; //edges
vector<int> c; //cycle length
vector<bool> uc; //cycle used

int n,m;
int a,b;
int ans;

void input()
{
    cin>>n>>m>>a>>b;
    --a;
    --b;
    int u,v;
    for (int i=0;i<m;++i)
    {
        cin>>u>>v;
        --u;
        --v;
        e.push_back({u,v,0,ne[u].size(),ne[v].size()});
        ne[u].push_back({v,-1,0,ne[v].size()});
        ne[v].push_back({u,-1,0,ne[u].size()-1});
    }
}
void output()
{
    cout<<ans<<endl;
}

int u[MAX_N];
int us[MAX_N];

int findU(int a)
{
    if (u[a]==a) return a;
    return u[a]=findU(u[a]);
}
bool unite(int a, int b)
{
    a=findU(a);
    b=findU(b);
    if (a==b) return 0;
    if (us[a]>us[b])
    {
        us[a]+=us[b];
        u[b]=u[a];
    }
    else
    {
        us[b]+=us[a];
        u[a]=u[b];
    }
    return 1;
}

void build_tree()
{
    bool un;
    for (int i=0;i<n;++i)
    {
        u[i]=i;
        us[i]=1;
    }
    for (int i=0;i<m;++i)
    {
        un=unite(e[i].f,e[i].t);
        if (un) e[i].inTree=1;
        else e[i].inTree=0;
        ne[e[i].f][e[i].ind1].inTree=e[i].inTree;
        ne[e[i].t][e[i].ind2].inTree=e[i].inTree;
    }
}
queue<int> q;
int vis[MAX_N];
void find_cycle(int i)
{
    int s=e[i].f;
    int t=e[i].t;
    int curr=c.size();
    c.push_back(1);
    uc.push_back(0);
    ne[s][e[i].ind1].cycle=curr;
    ne[t][e[i].ind2].cycle=curr;
    for (int i=0;i<n;++i)
    {
        vis[i]=-1;
    }
    while(!q.empty())
    {
        q.pop();
    }
    q.push(s);
    vis[s]=-2;
    int currv;
    int node;
    while(!q.empty())
    {
        node=q.front();
        if (node==t) break;
        q.pop();
        for (int j=0;j<ne[node].size();++j)
        {
            currv=ne[node][j].t;
            if (ne[node][j].inTree==1 && ne[node][j].cycle==-1 && vis[currv]==-1)
            {
                q.push(currv);
                vis[currv]=ne[node][j].indrev;
            }
        }
    }
    node=t;
    while(node!=s)
    {
        ++c[curr];
        currv=ne[node][vis[node]].t;
        ne[node][vis[node]].cycle=curr;
        ne[currv][ne[node][vis[node]].indrev].cycle=curr;
        node=currv;
    }
}

void find_cycles()
{
    build_tree();
    for (int i=0;i<m;++i)
    {
        if (e[i].inTree==0) find_cycle(i);
    }
    /*for (int i=0;i<n;++i)
    {
        cerr<<"\n"<<i+1<<":\n";
        for (int j=0;j<ne[i].size();++j)
        {
            cerr<<ne[i][j].t+1<<" "<<ne[i][j].cycle+1<<endl;
        }
    }
    cerr<<"\nCycles:\n";
    for (int i=0;i<c.size();++i)
    {
        cerr<<i+1<<": "<<c[i]<<endl;
    }
    cerr<<endl;*/
}

int spl=0;

void find_shortest_path()
{
    for (int i=0;i<n;++i)
    {
        vis[i]=-1;
    }
    while(!q.empty())
    {
        q.pop();
    }
    vis[a]=-2;
    q.push(a);
    int node,currv;
    while(!q.empty())
    {
        node=q.front();
        q.pop();
        if (node==b) break;
        for (int i=0;i<ne[node].size();++i)
        {
            currv=ne[node][i].t;
            if (vis[currv]==-1)
            {
                vis[currv]=ne[node][i].indrev;
                q.push(currv);
            }
        }
    }
    spl=0;
    node=b;
    while (node!=a)
    {
        ++spl;
        currv=ne[node][vis[node]].t;
        uc[ne[node][vis[node]].cycle]=1;
        node=currv;
    }
    //cerr<<"\nSpl: "<<spl<<"\n";
}

void find_longest_path()
{
    ans=0;
    //cerr<<"\nGoes trough: ";
    for (int i=0;i<c.size();++i)
    {
        if (uc[i]==1)
        {
            //cerr<<i+1<<" ";
            ans+=c[i];
        }
    }
    //cerr<<endl;
    ans-=spl;
}

void solve()
{
    find_cycles();
    find_shortest_path();
    find_longest_path();
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();
    output();

    return 0;
}
