#include <iostream>
using namespace std;

int n = 4;
bool used[100];

struct Point {
    double x;
    double y;
    double index;
};

Point findCenter (Point points[]) {
    Point center;
    double sumX = 0;
    double sumY = 0;
    for (double i = 0; i < n; i++) {
        sumX = ((double)(points[(int)i].x))/(i + 1) + sumX*(i/(i+1));
        sumY = ((double)(points[(int)i].y))/(i + 1) + sumY*(i/(i+1));
    }
    center.x = (double)sumX;
    center.y = (double)sumY;
    return center;
}

bool checkOutPolygon(Point points[]) {
    Point center = findCenter(points);
    for (int i = 1; i < n; i++) {
        double k = (points[i].y - points[i - 1].y) / (points[i].x - points[i - 1].x);
        if (i == n - 1) {
            double y = k * (points[0].x - points[i].x) + points[i].y;
            double centerY = k * (center.x - points[i].x) + points[i].y;
            if (y > points[0].y && center.y < centerY) {
                return false;
            } else if (y < points[0].y && center.y > centerY) {
                return false;
            }
        }


        double y = k * (points[i+1].x - points[i].x) + points[i].y;
        double centerY = k * (center.x - points[i].x) + points[i].y;
        if (y > points[i+1].y && center.y < centerY) {
            return false;
        } else if (y < points[i+1].y && center.y > centerY) {
            return false;
        }
    }
    return true;
}

double det (Point points[], int length) {
    double result;

    for (int i = 0; i < length - 1; i++) {
        result += points[i].x * points[i + 1].y - points[i].y * points[i + 1].x;
    }
    result += points[length - 1].x * points[0].y - points[length - 1].y * points[0].x;
    if (result < 0) {
        result = -result;
    }
    return result;
}

void removePoint (Point points[], int index, Point result[]) {
    bool flag = false;
    for (int i = 0; i < n - 1; i++) {
        int currentIndex = i;
        if (i == index) {
            flag = true;
        }
        if (flag) {
            currentIndex++;
        }
        result[i] = points[currentIndex];
    }
}

bool checkPolygon(Point points[]) {
    double oldDet = det (points, n);
    for (int i = 0; i < n; i++) {
        Point newPoints[n - 1];
        removePoint(points, i, newPoints);
        double newDet = det(newPoints, n - 1);
        if (newDet > oldDet) {
            return false;
        }
    }
    return true;
}

Point makeMove(Point jumper, Point relativeBody) {
    Point result;
    result.x = 2 * relativeBody.x - jumper.x;
    result.y = 2 * relativeBody.y - jumper.y;
    return result;
}

bool makeNextPermutation (Point points[], Point result[], int index) {
    if (index == n) {
        if (checkPolygon(result)) {
            return true;
        } else return false;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            result[index] = points[i];
            used[i] = true;
            bool good = makeNextPermutation(points, result, index + 1);
            if (good) return true;
            used[i] = false;
        }
    }
}


int main () {
    cin >> n;
    Point points[n];
    Point newPoints[n];
    for (int i = 0; i < n; i++) {
        cin >> points[i].x >> points[i].y;
        points[i].index = i;
    }

    bool flag = makeNextPermutation(points, newPoints, 0);
    if (flag) {
        cout << 0;
    }

    Point* pointPointer = newPoints;
    Point* newPointsPointer = newPoints;
    int i = 0;
    Point moves[n];
    while (i < n - 1) {
        *pointPointer = makeMove(pointPointer[i], pointPointer[i + 1]);
        moves[i] = {pointPointer[i].index, pointPointer[i + 1].index, - 1};
        Point temp[n];
        newPointsPointer = temp;
        bool flag1 = (makeNextPermutation(pointPointer, newPointsPointer, 0));
        if (flag1) {
                cout << i + 1;
            for (int j = 0; j < i; j++) {
                cout << moves[i].x << " " << moves[i].y;
            }
        }
        i++;
    }
    return 0;
}
