#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 1007;
const int K = 207;
const int INF = (1e9) + 7;

int n,k;
char a[N];
int cost[N][N];
//bool used[N][K];
int dp[N][K];
int shortest[N][K],longest[N][K];
//int state[N][K];

vector < int > get_indices(int l, int r) {
    vector < int > ans;
    stack < int > s;

    for(int i=l;i<=r;i++) {
        if(a[i]=='(') s.push(i);
        else if(!s.empty()) ans.push_back(s.top()),s.pop(),ans.push_back(i);
    }

    sort(ans.begin(),ans.end());
    return ans;
}

void print_part(int idx, int l, int r) {
    printf("%d,[%d,%d],%d:", idx, l, r, cost[l][r]);
    vector < int > v=get_indices(l,r);
    for(int i=0;i<(int)(v.size());i++) {
        if(i>0) printf(" ");
        printf("%d", v[i]);
    }
    printf("\n");
}

void calculate_states() {
    int i,pos,parts,ans,curr;

    for(parts=1;parts<=k;parts++) dp[0][parts]=INF;
    
    for(pos=1;pos<=n;pos++) {
        dp[pos][0]=INF;

        for(parts=1;parts<=k;parts++) {
            ans=INF;

            for(i=parts;i<=pos;i++) {
                curr=cost[i][pos]+dp[i-1][parts-1];
                
                if(curr<ans) {
                    ans=curr;
                    shortest[pos][parts]=longest[pos][parts]=i;
                }
                else if(curr==ans) {
                    shortest[pos][parts]=i;
                }
            }

            dp[pos][parts]=ans;
        }
    }
}

void restore_longest() {
    vector < pair < int, int > > v;

    int pos=n,parts=k;

    while(pos) {
        int i=longest[pos][parts];
        v.push_back(make_pair(i,pos));
        --parts;
        pos=i-1;
    }

    reverse(v.begin(),v.end());
    for(int i=0;i<(int)(v.size());i++) print_part(i+1,v[i].first,v[i].second);
}

void restore_shortest() {
    vector < pair < int, int > > v;

    int pos=n,parts=k;

    while(pos) {
        int i=shortest[pos][parts];
        v.push_back(make_pair(i,pos));
        --parts;
        pos=i-1;
    }

    reverse(v.begin(),v.end());
    for(int i=0;i<(int)(v.size());i++) print_part(i+1,v[i].first,v[i].second);
}

/*int recurse(int pos, int parts) {
    if(pos<1) return parts==0 ? 0 : INF;
    if(used[pos][parts]) return state[pos][parts];
    int ans=INF,i;
    for(i=1;i<=pos;i++) {
        ans=min(ans,cost[i][pos]+recurse(i-1,parts-1));
    }
    used[pos][parts]=true;
    return state[pos][parts]=ans;
}*/

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j;

    scanf("%s", a+1);
    n=strlen(a+1);
    scanf("%d", &k);

    for(i=1;i<=n;i++) {
        int sum=0,cnt=0;
        for(j=i;j<=n;j++) {
            if(a[j]=='(') ++cnt;
            else if(cnt>0) --cnt,sum+=2;
            cost[i][j]=sum;
        }
    }

    calculate_states();
    printf("%d\n", dp[n][k]);
    restore_longest();
    restore_shortest();

    return 0;
}
