#include <iostream>
#include <string>
#include <stack>
#include <vector>
#include <utility>
#include <algorithm>
#define fi first
#define se second
using namespace std;

const int MAXN = 1024;
const int MAXK = 128;
const int INF = 1 << 20;
const int EPS = 300;

string s;
int n, k;
int dp[MAXN][MAXK], pr[MAXN][MAXK];
int oc[MAXN][MAXN];

void toZero()
{
    for (int i = 0; i < MAXN; ++ i)
    {
        for (int j = 0; j < MAXK; ++ j)
        {
            dp[i][j] = pr[i][j] = INF;
        }
    }
}

void Precomp()
{
    for (int i = 0; i < n; ++ i)
    {
        int o = 0, c = 0;
        for (int j = i; j < n; ++ j)
        {
            if (s[j] == '(') o++;
            else if (o > c) c++;
            oc[i][j] = 2 * min(o, c);
            // cout << i << ' ' << j << ' ' << oc[i][j] << endl;
        }
    }
}

void DPF()
{
    toZero();
    for (int i = 0; i < n; ++ i)
    {
        dp[i][1] = oc[0][i];
        pr[i][1] = -1;
        // cout << dp[i][1];
        for (int j = 2; j <= k; ++ j)
        {
            int br = 0;
            if (i >= 1 and pr[i - 1][j] != -1 and pr[i - 1][j] < 1048576 and dp[i - 1][j] < 1048576) br = pr[i - 1][j] - EPS;
            for (int ij = i - 1; ij >= max(0, br); -- ij)
            {
                if (dp[i][j] >= dp[ij][j - 1] + oc[ij + 1][i])
                {
                    dp[i][j] = dp[ij][j - 1] + oc[ij + 1][i];
                    pr[i][j] = ij;
                }
            }
            // cout << ' ' << dp[i][j];
        }
        // cout << endl;
    }

    cout << dp[n - 1][k] << endl;

    int x = n - 1, y = k;
    stack<pair<int, int>> st;
    while (x != -1)
    {
        st.emplace(pr[x][y] + 1, x);
        x = pr[x][y];
        y--;
    }


    for (int i = 1; i <= k; ++ i)
    {
        cout << i << ',';
        cout << '[' << st.top().fi + 1 << ',' << st.top().se + 1 << "],";

        int o = 0, c = 0;
        int l = st.top().fi, r = st.top().se;
        vector<int> v;
        stack<int> braces;
        for (int j = l; j <= r; ++ j)
        {
            if (s[j] == '(')
            {
                 braces.push(j + 1);
            }
            if (s[j] == '(' and o < oc[l][r] / 2)
            {
                o++;
            }
            if (s[j] == ')' and o > c)
            {
                v.push_back(braces.top());
                braces.pop();
                v.push_back(j + 1);
                c++;
            }
        }
        sort(v.begin(), v.end());
        cout << v.size() << ":";
        for (int x : v)
        {
            cout << x << ' ';
        }
        cout << endl;
        st.pop();
    }
}

void DPS()
{
    toZero();
    for (int i = 0; i < n; ++ i)
    {
        dp[i][1] = oc[0][i];
        pr[i][1] = -1;
        // cout << dp[i][1];
        for (int j = 2; j <= k; ++ j)
        {
            int br = 0;
            if (i >= 1 and pr[i - 1][j] != -1 and pr[i - 1][j] < 1048576 and dp[i - 1][j] < 1048576) br = pr[i - 1][j] - EPS;
            for (int ij = i - 1; ij >= max(0, br); -- ij)
            {
                if (dp[i][j] > dp[ij][j - 1] + oc[ij + 1][i])
                {
                    dp[i][j] = dp[ij][j - 1] + oc[ij + 1][i];
                    pr[i][j] = ij;
                }
            }
            // cout << ' ' << dp[i][j];
        }
        // cout << endl;
    }

    // cout << dp[n - 1][k] << endl;

    int x = n - 1, y = k;
    stack<pair<int, int>> st;
    while (x != -1)
    {
        st.emplace(pr[x][y] + 1, x);
        x = pr[x][y];
        y--;
    }


    for (int i = 1; i <= k; ++ i)
    {
        cout << i << ',';
        cout << '[' << st.top().fi + 1 << ',' << st.top().se + 1 << "],";

        int o = 0, c = 0;
        int l = st.top().fi, r = st.top().se;
        vector<int> v;
        stack<int> braces;
        for (int j = l; j <= r; ++ j)
        {
            if (s[j] == '(')
            {
                 braces.push(j + 1);
            }
            if (s[j] == '(' and o < oc[l][r] / 2)
            {
                o++;
            }
            if (s[j] == ')' and o > c)
            {
                v.push_back(braces.top());
                braces.pop();
                v.push_back(j + 1);
                c++;
            }
        }
        sort(v.begin(), v.end());
        cout << v.size() << ":";
        for (int x : v)
        {
            cout << x << ' ';
        }
        cout << endl;
        st.pop();
    }
}

int main()
{
    cin >> s;
    n = s.size();
    cin >> k;

    Precomp();

    DPF();
    DPS();

    return 0;
}
