#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
#include <cstdlib>
#define fi first
#define se second
using namespace std;

const int MAXN = 128;

struct Point
{
    int x, y, z;
};

int n;
Point a[MAXN];
vector<pair<int, int>> v;

long long cross_product(Point A, Point B, Point C, Point D)
{
    long long x1 = B.x - A.x, y1 = B.y - A.y;
    long long x2 = D.x - C.x, y2 = D.y - C.y;
    return x1 * y2 - x2 * y1;
}

long long dist(Point A, Point B)
{
    long long x = A.x - B.x, y = A.y - B.y;
    return x * x + y * y;
}

bool cmp(Point A, Point B)
{
    return cross_product(a[1], A, a[1], B) > 0;
}


void Init()
{
    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i].x >> a[i].y;
        a[i].z = i;
    }
}

int Check()
{
    for (int i = 2; i <= n; ++ i)
    {
        if (a[i].x < a[1].x or (a[i].x == a[1].x and a[i].y < a[1].y))
        {
            swap(a[1], a[i]);
        }
    }

    sort(a + 2, a + n + 1, cmp);

    if (rand() % 2) for (int i = 3; i < n; ++ i)
    {
        if (cross_product(a[i - 1], a[i], a[i], a[i + 1]) > 0)
        {
            return i;
        }
    }
    else for (int i = n - 1; i >= 3; -- i)
    {
        if (cross_product(a[i - 1], a[i], a[i], a[i + 1]) > 0)
        {
            return i;
        }
    }
    return -1;
}

int Farthest(int p)
{
    int q = 1;
    for (int i = 2; i <= n; ++ i)
    {
        if (i == p) continue;
        if (dist(a[p], a[i]) > dist(a[p], a[q])) q = i;
    }
    return q;
}

void Print()
{
    cout << v.size() << endl;
    for (int i = 0; i < v.size(); ++ i)
    {
        cout << v[i].fi << ' ' << v[i].se << endl;
    }
}

int main()
{
    Init();

    while (true)
    {
        int p = Check();
        if (p == -1 or v.size() > 10000) break;

        int q = Farthest(p);
        v.emplace_back(a[p].z, a[q].z);

        a[p].x = a[p].x + (a[p].x - a[q].x);
        a[p].y = a[p].y + (a[p].y - a[q].y);
    }

    Print();
    return 0;
}

/*
6
3 5
4 3
3 1
11 4
7 7
7 2
*/
